/* JournalEditor.c generated by valac 0.30.0, the Vala compiler
 * generated from JournalEditor.vala, do not modify */

/*
 * DayJournal
 *
 * Copyright (C) 2013 Zach Burnham <thejambi@gmail.com>
 *
 * DayJournal is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * DayJournal is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define TYPE_JOURNAL_EDITOR (journal_editor_get_type ())
#define JOURNAL_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_JOURNAL_EDITOR, JournalEditor))
#define JOURNAL_EDITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_JOURNAL_EDITOR, JournalEditorClass))
#define IS_JOURNAL_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_JOURNAL_EDITOR))
#define IS_JOURNAL_EDITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_JOURNAL_EDITOR))
#define JOURNAL_EDITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_JOURNAL_EDITOR, JournalEditorClass))

typedef struct _JournalEditor JournalEditor;
typedef struct _JournalEditorClass JournalEditorClass;
typedef struct _JournalEditorPrivate JournalEditorPrivate;

#define TYPE_ACTION (action_get_type ())
#define ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACTION, Action))
#define ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACTION, ActionClass))
#define IS_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACTION))
#define IS_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACTION))
#define ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACTION, ActionClass))

typedef struct _Action Action;
typedef struct _ActionClass ActionClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_JOURNAL_ENTRY (journal_entry_get_type ())
#define JOURNAL_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_JOURNAL_ENTRY, JournalEntry))
#define JOURNAL_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_JOURNAL_ENTRY, JournalEntryClass))
#define IS_JOURNAL_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_JOURNAL_ENTRY))
#define IS_JOURNAL_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_JOURNAL_ENTRY))
#define JOURNAL_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_JOURNAL_ENTRY, JournalEntryClass))

typedef struct _JournalEntry JournalEntry;
typedef struct _JournalEntryClass JournalEntryClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _action_unref0(var) ((var == NULL) ? NULL : (var = (action_unref (var), NULL)))
typedef struct _ActionPrivate ActionPrivate;
typedef struct _ParamSpecAction ParamSpecAction;

struct _JournalEditor {
	GObject parent_instance;
	JournalEditorPrivate * priv;
};

struct _JournalEditorClass {
	GObjectClass parent_class;
};

struct _JournalEditorPrivate {
	GtkTextBuffer* _buffer;
	gint undoMax;
	GeeArrayList* undos;
	GeeArrayList* redos;
	gulong onInsertConnection;
	gulong onDeleteConnection;
};

struct _Action {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ActionPrivate * priv;
};

struct _ActionClass {
	GTypeClass parent_class;
	void (*finalize) (Action *self);
};

struct _ActionPrivate {
	gchar* _action;
	gchar* _text;
	gint _offset;
};

struct _ParamSpecAction {
	GParamSpec parent_instance;
};


static gpointer journal_editor_parent_class = NULL;
static gpointer action_parent_class = NULL;

GType journal_editor_get_type (void) G_GNUC_CONST;
gpointer action_ref (gpointer instance);
void action_unref (gpointer instance);
GParamSpec* param_spec_action (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_action (GValue* value, gpointer v_object);
void value_take_action (GValue* value, gpointer v_object);
gpointer value_get_action (const GValue* value);
GType action_get_type (void) G_GNUC_CONST;
#define JOURNAL_EDITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_JOURNAL_EDITOR, JournalEditorPrivate))
enum  {
	JOURNAL_EDITOR_DUMMY_PROPERTY,
	JOURNAL_EDITOR_BUFFER
};
JournalEditor* journal_editor_new (GtkTextBuffer* buffer);
JournalEditor* journal_editor_construct (GType object_type, GtkTextBuffer* buffer);
static void journal_editor_set_buffer (JournalEditor* self, GtkTextBuffer* value);
static void journal_editor_connectSignals (JournalEditor* self);
static void journal_editor_getStartIter (JournalEditor* self, GtkTextIter* result);
GtkTextBuffer* journal_editor_get_buffer (JournalEditor* self);
static void journal_editor_getEndIter (JournalEditor* self, GtkTextIter* result);
gchar* journal_editor_getText (JournalEditor* self);
GType journal_entry_get_type (void) G_GNUC_CONST;
void journal_editor_startNewEntry (JournalEditor* self, const gchar* origText, GtkTextView* textView, JournalEntry* entry);
static void journal_editor_disconnectSignals (JournalEditor* self);
#define ENTRY_IMAGE_ANCHORS_IMG_TAG_START "<img class='dayjournalimage' src='"
#define ENTRY_IMAGE_ANCHORS_IMG_TAG_END "' />"
void zystem_debug (const gchar* s);
gchar* file_utility_getPathFromImgTag (const gchar* imgTag);
const gchar* user_data_get_djDirPath (void);
static void journal_editor_getIterAtOffset (JournalEditor* self, gint offset, GtkTextIter* result);
void journal_editor_addImageAtIterForEntry (JournalEditor* self, JournalEntry* entry, GtkTextView* textView, const gchar* relativePath, const gchar* imgFilePath, GtkTextIter* imgIter);
void journal_entry_addImage (JournalEntry* self, const gchar* relativePath, const gchar* fullPath, GtkImage* img, GtkTextChildAnchor* anchor, GtkTextBuffer* buffer);
void journal_editor_append (JournalEditor* self, const gchar* text);
void journal_editor_prepend (JournalEditor* self, const gchar* text);
void journal_editor_prependDateToEntry (JournalEditor* self, const gchar* dateHeading);
void journal_editor_insertAtCursor (JournalEditor* self, const gchar* text);
static void journal_editor_getCurrentIter (JournalEditor* self, GtkTextIter* result);
void journal_editor_cursorToEnd (JournalEditor* self);
void journal_editor_cursorToStart (JournalEditor* self);
GtkTextChildAnchor* journal_editor_getAnchorAtCurrent (JournalEditor* self);
static void journal_editor_highlight (JournalEditor* self);
void journal_editor_undo (JournalEditor* self);
Action* journal_editor_doAction (JournalEditor* self, Action* action);
const gchar* action_get_action (Action* self);
gint action_get_offset (Action* self);
const gchar* action_get_text (Action* self);
void action_set_action (Action* self, const gchar* value);
void journal_editor_redo (JournalEditor* self);
static void journal_editor_onInsertText (JournalEditor* self, GtkTextIter* iter, const gchar* text, gint length);
Action* action_new (const gchar* action, gint offset, const gchar* text);
Action* action_construct (GType object_type, const gchar* action, gint offset, const gchar* text);
static void journal_editor_onDeleteRange (JournalEditor* self, GtkTextIter* startIter, GtkTextIter* endIter);
static void journal_editor_addUndo (JournalEditor* self, Action* cmd);
static void __lambda4_ (JournalEditor* self, GtkTextIter* iter, const gchar* text, gint length);
static void ___lambda4__gtk_text_buffer_insert_text (GtkTextBuffer* _sender, GtkTextIter* pos, const gchar* new_text, gint new_text_length, gpointer self);
static void __lambda5_ (JournalEditor* self, GtkTextIter* startIter, GtkTextIter* endIter);
static void ___lambda5__gtk_text_buffer_delete_range (GtkTextBuffer* _sender, GtkTextIter* start, GtkTextIter* end, gpointer self);
static void journal_editor_finalize (GObject* obj);
static void _vala_journal_editor_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_journal_editor_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define ACTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ACTION, ActionPrivate))
enum  {
	ACTION_DUMMY_PROPERTY
};
void action_set_text (Action* self, const gchar* value);
void action_set_offset (Action* self, gint value);
static void action_finalize (Action* obj);


/**
 * Constructor for JournalEditor.
 */
JournalEditor* journal_editor_construct (GType object_type, GtkTextBuffer* buffer) {
	JournalEditor * self = NULL;
	GtkTextBuffer* _tmp0_ = NULL;
	GeeArrayList* _tmp1_ = NULL;
	GeeArrayList* _tmp2_ = NULL;
	g_return_val_if_fail (buffer != NULL, NULL);
	self = (JournalEditor*) g_object_new (object_type, NULL);
	_tmp0_ = buffer;
	journal_editor_set_buffer (self, _tmp0_);
	self->priv->undoMax = 1000;
	_tmp1_ = gee_array_list_new (TYPE_ACTION, (GBoxedCopyFunc) action_ref, action_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->undos);
	self->priv->undos = _tmp1_;
	_tmp2_ = gee_array_list_new (TYPE_ACTION, (GBoxedCopyFunc) action_ref, action_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->redos);
	self->priv->redos = _tmp2_;
	journal_editor_connectSignals (self);
	return self;
}


JournalEditor* journal_editor_new (GtkTextBuffer* buffer) {
	return journal_editor_construct (TYPE_JOURNAL_EDITOR, buffer);
}


static void journal_editor_getStartIter (JournalEditor* self, GtkTextIter* result) {
	GtkTextIter startIter = {0};
	GtkTextBuffer* _tmp0_ = NULL;
	GtkTextIter _tmp1_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_buffer;
	gtk_text_buffer_get_start_iter (_tmp0_, &_tmp1_);
	startIter = _tmp1_;
	*result = startIter;
	return;
}


static void journal_editor_getEndIter (JournalEditor* self, GtkTextIter* result) {
	GtkTextIter endIter = {0};
	GtkTextBuffer* _tmp0_ = NULL;
	GtkTextIter _tmp1_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_buffer;
	gtk_text_buffer_get_end_iter (_tmp0_, &_tmp1_);
	endIter = _tmp1_;
	*result = endIter;
	return;
}


gchar* journal_editor_getText (JournalEditor* self) {
	gchar* result = NULL;
	GtkTextBuffer* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_buffer;
	g_object_get (_tmp0_, "text", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


static gint string_index_of (const gchar* self, const gchar* needle, gint start_index) {
	gint result = 0;
	gchar* _result_ = NULL;
	gint _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = start_index;
	_tmp1_ = needle;
	_tmp2_ = strstr (((gchar*) self) + _tmp0_, (gchar*) _tmp1_);
	_result_ = _tmp2_;
	_tmp3_ = _result_;
	if (_tmp3_ != NULL) {
		gchar* _tmp4_ = NULL;
		_tmp4_ = _result_;
		result = (gint) (_tmp4_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	glong _tmp2_ = 0L;
	glong _tmp5_ = 0L;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_ = 0L;
	gboolean _tmp12_ = FALSE;
	glong _tmp13_ = 0L;
	glong _tmp16_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	gchar* _tmp21_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	_tmp2_ = start;
	if (_tmp2_ < ((glong) 0)) {
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		_tmp3_ = string_length;
		_tmp4_ = start;
		start = _tmp3_ + _tmp4_;
	}
	_tmp5_ = end;
	if (_tmp5_ < ((glong) 0)) {
		glong _tmp6_ = 0L;
		glong _tmp7_ = 0L;
		_tmp6_ = string_length;
		_tmp7_ = end;
		end = _tmp6_ + _tmp7_;
	}
	_tmp9_ = start;
	if (_tmp9_ >= ((glong) 0)) {
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		_tmp10_ = start;
		_tmp11_ = string_length;
		_tmp8_ = _tmp10_ <= _tmp11_;
	} else {
		_tmp8_ = FALSE;
	}
	g_return_val_if_fail (_tmp8_, NULL);
	_tmp13_ = end;
	if (_tmp13_ >= ((glong) 0)) {
		glong _tmp14_ = 0L;
		glong _tmp15_ = 0L;
		_tmp14_ = end;
		_tmp15_ = string_length;
		_tmp12_ = _tmp14_ <= _tmp15_;
	} else {
		_tmp12_ = FALSE;
	}
	g_return_val_if_fail (_tmp12_, NULL);
	_tmp16_ = start;
	_tmp17_ = end;
	g_return_val_if_fail (_tmp16_ <= _tmp17_, NULL);
	_tmp18_ = start;
	_tmp19_ = end;
	_tmp20_ = start;
	_tmp21_ = g_strndup (((gchar*) self) + _tmp18_, (gsize) (_tmp19_ - _tmp20_));
	result = _tmp21_;
	return result;
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		_tmp0_ = old;
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		regex = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch6_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp6_ = regex;
		_tmp7_ = replacement;
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) -1, 0, _tmp7_, 0, &_inner_error_);
		_tmp5_ = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch6_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp9_ = _tmp5_;
		_tmp5_ = NULL;
		result = _tmp9_;
		_g_free0 (_tmp5_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally6;
	__catch6_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally6:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	_tmp0_ = str;
	_tmp1_ = maxlen;
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
	end = _tmp2_;
	_tmp3_ = end;
	if (_tmp3_ == NULL) {
		glong _tmp4_ = 0L;
		_tmp4_ = maxlen;
		result = _tmp4_;
		return result;
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp5_ = end;
		_tmp6_ = str;
		result = (glong) (_tmp5_ - _tmp6_);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	glong _tmp8_ = 0L;
	glong _tmp14_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	gchar* _tmp22_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = offset;
	if (_tmp1_ >= ((glong) 0)) {
		glong _tmp2_ = 0L;
		_tmp2_ = len;
		_tmp0_ = _tmp2_ >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
		_tmp3_ = offset;
		_tmp4_ = len;
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
		string_length = _tmp5_;
	} else {
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		_tmp6_ = strlen (self);
		_tmp7_ = _tmp6_;
		string_length = (glong) _tmp7_;
	}
	_tmp8_ = offset;
	if (_tmp8_ < ((glong) 0)) {
		glong _tmp9_ = 0L;
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		_tmp9_ = string_length;
		_tmp10_ = offset;
		offset = _tmp9_ + _tmp10_;
		_tmp11_ = offset;
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
	} else {
		glong _tmp12_ = 0L;
		glong _tmp13_ = 0L;
		_tmp12_ = offset;
		_tmp13_ = string_length;
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
	}
	_tmp14_ = len;
	if (_tmp14_ < ((glong) 0)) {
		glong _tmp15_ = 0L;
		glong _tmp16_ = 0L;
		_tmp15_ = string_length;
		_tmp16_ = offset;
		len = _tmp15_ - _tmp16_;
	}
	_tmp17_ = offset;
	_tmp18_ = len;
	_tmp19_ = string_length;
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
	_tmp20_ = offset;
	_tmp21_ = len;
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
	result = _tmp22_;
	return result;
}


void journal_editor_startNewEntry (JournalEditor* self, const gchar* origText, GtkTextView* textView, JournalEntry* entry) {
	gchar* text = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GeeArrayList* _tmp2_ = NULL;
	GeeArrayList* _tmp3_ = NULL;
	GtkTextBuffer* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gint i = 0;
	const gchar* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gint iEnd = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (origText != NULL);
	g_return_if_fail (textView != NULL);
	g_return_if_fail (entry != NULL);
	_tmp0_ = origText;
	_tmp1_ = g_strdup (_tmp0_);
	text = _tmp1_;
	_tmp2_ = self->priv->undos;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp2_);
	_tmp3_ = self->priv->redos;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp3_);
	journal_editor_disconnectSignals (self);
	_tmp4_ = self->priv->_buffer;
	_tmp5_ = text;
	gtk_text_buffer_set_text (_tmp4_, _tmp5_, -1);
	_tmp6_ = text;
	_tmp7_ = string_index_of (_tmp6_, ENTRY_IMAGE_ANCHORS_IMG_TAG_START, 0);
	i = _tmp7_;
	iEnd = 0;
	while (TRUE) {
		gint _tmp8_ = 0;
		const gchar* _tmp9_ = NULL;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
		gchar* _tmp19_ = NULL;
		gchar* _tmp20_ = NULL;
		gchar* _tmp21_ = NULL;
		gint _tmp22_ = 0;
		gchar* _tmp23_ = NULL;
		gchar* _tmp24_ = NULL;
		gchar* _tmp25_ = NULL;
		gchar* _tmp26_ = NULL;
		gchar* relativePath = NULL;
		const gchar* _tmp27_ = NULL;
		gint _tmp28_ = 0;
		gint _tmp29_ = 0;
		gchar* _tmp30_ = NULL;
		gchar* _tmp31_ = NULL;
		gchar* _tmp32_ = NULL;
		gchar* _tmp33_ = NULL;
		gchar* fullPath = NULL;
		const gchar* _tmp34_ = NULL;
		const gchar* _tmp35_ = NULL;
		const gchar* _tmp36_ = NULL;
		gchar* _tmp37_ = NULL;
		const gchar* _tmp38_ = NULL;
		gint _tmp39_ = 0;
		gchar* _tmp40_ = NULL;
		gchar* _tmp41_ = NULL;
		gchar* _tmp42_ = NULL;
		gchar* _tmp43_ = NULL;
		const gchar* _tmp44_ = NULL;
		gint _tmp45_ = 0;
		gchar* _tmp46_ = NULL;
		gchar* _tmp47_ = NULL;
		gchar* _tmp48_ = NULL;
		GtkTextIter iIter = {0};
		gint _tmp49_ = 0;
		GtkTextIter _tmp50_ = {0};
		GtkTextIter iEndIter = {0};
		gint _tmp51_ = 0;
		GtkTextIter _tmp52_ = {0};
		GtkTextBuffer* _tmp53_ = NULL;
		JournalEntry* _tmp54_ = NULL;
		GtkTextView* _tmp55_ = NULL;
		const gchar* _tmp56_ = NULL;
		const gchar* _tmp57_ = NULL;
		gint _tmp58_ = 0;
		GtkTextIter _tmp59_ = {0};
		gint _tmp60_ = 0;
		const gchar* _tmp61_ = NULL;
		gint _tmp62_ = 0;
		gint _tmp63_ = 0;
		_tmp8_ = i;
		if (!(_tmp8_ >= 0)) {
			break;
		}
		_tmp9_ = text;
		_tmp10_ = i;
		_tmp11_ = string_index_of (_tmp9_, ENTRY_IMAGE_ANCHORS_IMG_TAG_END, _tmp10_);
		iEnd = _tmp11_;
		_tmp12_ = iEnd;
		_tmp13_ = strlen (ENTRY_IMAGE_ANCHORS_IMG_TAG_END);
		_tmp14_ = _tmp13_;
		iEnd = _tmp12_ + _tmp14_;
		_tmp15_ = i;
		_tmp16_ = g_strdup_printf ("%i", _tmp15_);
		_tmp17_ = _tmp16_;
		_tmp18_ = g_strconcat ("IMAGE FOUND AT ", _tmp17_, NULL);
		_tmp19_ = _tmp18_;
		_tmp20_ = g_strconcat (_tmp19_, " to ", NULL);
		_tmp21_ = _tmp20_;
		_tmp22_ = iEnd;
		_tmp23_ = g_strdup_printf ("%i", _tmp22_);
		_tmp24_ = _tmp23_;
		_tmp25_ = g_strconcat (_tmp21_, _tmp24_, NULL);
		_tmp26_ = _tmp25_;
		zystem_debug (_tmp26_);
		_g_free0 (_tmp26_);
		_g_free0 (_tmp24_);
		_g_free0 (_tmp21_);
		_g_free0 (_tmp19_);
		_g_free0 (_tmp17_);
		_tmp27_ = text;
		_tmp28_ = i;
		_tmp29_ = iEnd;
		_tmp30_ = string_slice (_tmp27_, (glong) _tmp28_, (glong) _tmp29_);
		_tmp31_ = _tmp30_;
		_tmp32_ = file_utility_getPathFromImgTag (_tmp31_);
		_tmp33_ = _tmp32_;
		_g_free0 (_tmp31_);
		relativePath = _tmp33_;
		_tmp34_ = relativePath;
		_tmp35_ = user_data_get_djDirPath ();
		_tmp36_ = _tmp35_;
		_tmp37_ = string_replace (_tmp34_, "..", _tmp36_);
		fullPath = _tmp37_;
		_tmp38_ = text;
		_tmp39_ = i;
		_tmp40_ = string_substring (_tmp38_, (glong) 0, (glong) _tmp39_);
		_tmp41_ = _tmp40_;
		_tmp42_ = g_strconcat (_tmp41_, " ", NULL);
		_tmp43_ = _tmp42_;
		_tmp44_ = text;
		_tmp45_ = iEnd;
		_tmp46_ = string_substring (_tmp44_, (glong) _tmp45_, (glong) -1);
		_tmp47_ = _tmp46_;
		_tmp48_ = g_strconcat (_tmp43_, _tmp47_, NULL);
		_g_free0 (text);
		text = _tmp48_;
		_g_free0 (_tmp47_);
		_g_free0 (_tmp43_);
		_g_free0 (_tmp41_);
		_tmp49_ = i;
		journal_editor_getIterAtOffset (self, _tmp49_, &_tmp50_);
		iIter = _tmp50_;
		_tmp51_ = iEnd;
		journal_editor_getIterAtOffset (self, _tmp51_, &_tmp52_);
		iEndIter = _tmp52_;
		_tmp53_ = self->priv->_buffer;
		gtk_text_buffer_delete (_tmp53_, &iIter, &iEndIter);
		_tmp54_ = entry;
		_tmp55_ = textView;
		_tmp56_ = relativePath;
		_tmp57_ = fullPath;
		_tmp58_ = i;
		journal_editor_getIterAtOffset (self, _tmp58_, &_tmp59_);
		journal_editor_addImageAtIterForEntry (self, _tmp54_, _tmp55_, _tmp56_, _tmp57_, &_tmp59_);
		_tmp60_ = i;
		i = _tmp60_ + 1;
		_tmp61_ = text;
		_tmp62_ = i;
		_tmp63_ = string_index_of (_tmp61_, ENTRY_IMAGE_ANCHORS_IMG_TAG_START, _tmp62_);
		i = _tmp63_;
		_g_free0 (fullPath);
		_g_free0 (relativePath);
	}
	zystem_debug ("IMAGE FINDING TOTALLY COMPLETE");
	journal_editor_connectSignals (self);
	_g_free0 (text);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void journal_editor_addImageAtIterForEntry (JournalEditor* self, JournalEntry* entry, GtkTextView* textView, const gchar* relativePath, const gchar* imgFilePath, GtkTextIter* imgIter) {
	gint _tmp0_ = 0;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	GtkImage* img = NULL;
	const gchar* _tmp7_ = NULL;
	GtkImage* _tmp8_ = NULL;
	GtkTextChildAnchor* anchor = NULL;
	GtkTextBuffer* _tmp9_ = NULL;
	GtkTextIter _tmp10_ = {0};
	GtkTextChildAnchor* _tmp11_ = NULL;
	GtkTextChildAnchor* _tmp12_ = NULL;
	GdkPixbuf* pixbuf = NULL;
	GtkImage* _tmp13_ = NULL;
	GdkPixbuf* _tmp14_ = NULL;
	GdkPixbuf* _tmp15_ = NULL;
	gdouble w = 0.0;
	GdkPixbuf* _tmp16_ = NULL;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	gdouble h = 0.0;
	GdkPixbuf* _tmp19_ = NULL;
	gint _tmp20_ = 0;
	gint _tmp21_ = 0;
	gdouble _tmp22_ = 0.0;
	GtkTextView* _tmp32_ = NULL;
	GtkImage* _tmp33_ = NULL;
	GtkTextChildAnchor* _tmp34_ = NULL;
	GtkImage* _tmp35_ = NULL;
	JournalEntry* _tmp36_ = NULL;
	const gchar* _tmp37_ = NULL;
	const gchar* _tmp38_ = NULL;
	GtkImage* _tmp39_ = NULL;
	GtkTextChildAnchor* _tmp40_ = NULL;
	GtkTextBuffer* _tmp41_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (entry != NULL);
	g_return_if_fail (textView != NULL);
	g_return_if_fail (relativePath != NULL);
	g_return_if_fail (imgFilePath != NULL);
	g_return_if_fail (imgIter != NULL);
	_tmp0_ = gtk_text_iter_get_offset (imgIter);
	_tmp1_ = g_strdup_printf ("%i", _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat ("GOING TO addImageAtIter ", _tmp2_, NULL);
	_tmp4_ = _tmp3_;
	zystem_debug (_tmp4_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	_tmp5_ = relativePath;
	zystem_debug (_tmp5_);
	_tmp6_ = imgFilePath;
	zystem_debug (_tmp6_);
	_tmp7_ = imgFilePath;
	_tmp8_ = (GtkImage*) gtk_image_new_from_file (_tmp7_);
	g_object_ref_sink (_tmp8_);
	img = _tmp8_;
	_tmp9_ = self->priv->_buffer;
	_tmp10_ = *imgIter;
	_tmp11_ = gtk_text_buffer_create_child_anchor (_tmp9_, &_tmp10_);
	_tmp12_ = _g_object_ref0 (_tmp11_);
	anchor = _tmp12_;
	_tmp13_ = img;
	g_object_get (_tmp13_, "pixbuf", &_tmp14_, NULL);
	_tmp15_ = _tmp14_;
	pixbuf = _tmp15_;
	_tmp16_ = pixbuf;
	_tmp17_ = gdk_pixbuf_get_width (_tmp16_);
	_tmp18_ = _tmp17_;
	w = (gdouble) _tmp18_;
	_tmp19_ = pixbuf;
	_tmp20_ = gdk_pixbuf_get_height (_tmp19_);
	_tmp21_ = _tmp20_;
	h = (gdouble) _tmp21_;
	_tmp22_ = w;
	if (_tmp22_ > ((gdouble) 400)) {
		gdouble newH = 0.0;
		gdouble _tmp23_ = 0.0;
		gdouble _tmp24_ = 0.0;
		gdouble _tmp25_ = 0.0;
		GdkPixbuf* newPixbuf = NULL;
		GdkPixbuf* _tmp26_ = NULL;
		gdouble _tmp27_ = 0.0;
		GdkPixbuf* _tmp28_ = NULL;
		GtkImage* _tmp29_ = NULL;
		GdkPixbuf* _tmp30_ = NULL;
		_tmp23_ = w;
		_tmp24_ = w;
		_tmp25_ = h;
		newH = (1 - ((_tmp23_ - 400) / _tmp24_)) * _tmp25_;
		_tmp26_ = pixbuf;
		_tmp27_ = newH;
		_tmp28_ = gdk_pixbuf_scale_simple (_tmp26_, 400, (gint) _tmp27_, GDK_INTERP_BILINEAR);
		newPixbuf = _tmp28_;
		_tmp29_ = img;
		_tmp30_ = newPixbuf;
		gtk_image_set_from_pixbuf (_tmp29_, _tmp30_);
		_g_object_unref0 (newPixbuf);
	} else {
		gdouble _tmp31_ = 0.0;
		_tmp31_ = h;
		if (_tmp31_ > ((gdouble) 400)) {
		}
	}
	_tmp32_ = textView;
	_tmp33_ = img;
	_tmp34_ = anchor;
	gtk_text_view_add_child_at_anchor (_tmp32_, (GtkWidget*) _tmp33_, _tmp34_);
	_tmp35_ = img;
	gtk_widget_show_now ((GtkWidget*) _tmp35_);
	_tmp36_ = entry;
	_tmp37_ = relativePath;
	_tmp38_ = imgFilePath;
	_tmp39_ = img;
	_tmp40_ = anchor;
	_tmp41_ = self->priv->_buffer;
	journal_entry_addImage (_tmp36_, _tmp37_, _tmp38_, _tmp39_, _tmp40_, _tmp41_);
	_g_object_unref0 (pixbuf);
	_g_object_unref0 (anchor);
	_g_object_unref0 (img);
}


static void journal_editor_getIterAtOffset (JournalEditor* self, gint offset, GtkTextIter* result) {
	GtkTextIter iter = {0};
	GtkTextBuffer* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	GtkTextIter _tmp2_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_buffer;
	_tmp1_ = offset;
	gtk_text_buffer_get_iter_at_offset (_tmp0_, &_tmp2_, _tmp1_);
	iter = _tmp2_;
	*result = iter;
	return;
}


void journal_editor_append (JournalEditor* self, const gchar* text) {
	GtkTextIter iter = {0};
	GtkTextIter _tmp0_ = {0};
	GtkTextBuffer* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	journal_editor_getEndIter (self, &_tmp0_);
	iter = _tmp0_;
	_tmp1_ = self->priv->_buffer;
	_tmp2_ = text;
	_tmp3_ = text;
	_tmp4_ = strlen (_tmp3_);
	_tmp5_ = _tmp4_;
	gtk_text_buffer_insert (_tmp1_, &iter, _tmp2_, _tmp5_);
}


void journal_editor_prepend (JournalEditor* self, const gchar* text) {
	GtkTextIter startIter = {0};
	GtkTextIter _tmp0_ = {0};
	GtkTextBuffer* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	journal_editor_getStartIter (self, &_tmp0_);
	startIter = _tmp0_;
	_tmp1_ = self->priv->_buffer;
	_tmp2_ = text;
	_tmp3_ = text;
	_tmp4_ = strlen (_tmp3_);
	_tmp5_ = _tmp4_;
	gtk_text_buffer_insert (_tmp1_, &startIter, _tmp2_, _tmp5_);
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


void journal_editor_prependDateToEntry (JournalEditor* self, const gchar* dateHeading) {
	GtkTextBuffer* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (dateHeading != NULL);
	_tmp0_ = self->priv->_buffer;
	g_object_get (_tmp0_, "text", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp4_ = dateHeading;
	_tmp5_ = string_strip (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_str_has_prefix (_tmp3_, _tmp6_);
	_tmp8_ = !_tmp7_;
	_g_free0 (_tmp6_);
	_g_free0 (_tmp3_);
	if (_tmp8_) {
		const gchar* _tmp9_ = NULL;
		_tmp9_ = dateHeading;
		journal_editor_prepend (self, _tmp9_);
	}
}


/**
 * 
 */
void journal_editor_insertAtCursor (JournalEditor* self, const gchar* text) {
	GtkTextIter startIter = {0};
	GtkTextIter _tmp0_ = {0};
	GtkTextBuffer* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	journal_editor_getCurrentIter (self, &_tmp0_);
	startIter = _tmp0_;
	_tmp1_ = self->priv->_buffer;
	_tmp2_ = text;
	_tmp3_ = text;
	_tmp4_ = strlen (_tmp3_);
	_tmp5_ = _tmp4_;
	gtk_text_buffer_insert (_tmp1_, &startIter, _tmp2_, _tmp5_);
}


void journal_editor_cursorToEnd (JournalEditor* self) {
	GtkTextBuffer* _tmp0_ = NULL;
	GtkTextIter _tmp1_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_buffer;
	journal_editor_getEndIter (self, &_tmp1_);
	gtk_text_buffer_place_cursor (_tmp0_, &_tmp1_);
}


void journal_editor_cursorToStart (JournalEditor* self) {
	GtkTextBuffer* _tmp0_ = NULL;
	GtkTextIter _tmp1_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_buffer;
	journal_editor_getStartIter (self, &_tmp1_);
	gtk_text_buffer_place_cursor (_tmp0_, &_tmp1_);
}


GtkTextChildAnchor* journal_editor_getAnchorAtCurrent (JournalEditor* self) {
	GtkTextChildAnchor* result = NULL;
	GtkTextBuffer* _tmp0_ = NULL;
	GtkTextIter _tmp1_ = {0};
	GtkTextChildAnchor* _tmp2_ = NULL;
	GtkTextChildAnchor* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_buffer;
	journal_editor_getCurrentIter (self, &_tmp1_);
	_tmp2_ = gtk_text_buffer_create_child_anchor (_tmp0_, &_tmp1_);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	result = _tmp3_;
	return result;
}


static void journal_editor_getCurrentIter (JournalEditor* self, GtkTextIter* result) {
	GtkTextIter iter = {0};
	GtkTextBuffer* _tmp0_ = NULL;
	GtkTextBuffer* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	GtkTextIter _tmp4_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_buffer;
	_tmp1_ = self->priv->_buffer;
	g_object_get (_tmp1_, "cursor-position", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	gtk_text_buffer_get_iter_at_offset (_tmp0_, &_tmp4_, _tmp3_);
	iter = _tmp4_;
	*result = iter;
	return;
}


static void journal_editor_highlight (JournalEditor* self) {
	GtkTextIter startIter = {0};
	GtkTextIter _tmp0_ = {0};
	GtkTextIter endIter = {0};
	GtkTextIter _tmp1_ = {0};
	GtkTextBuffer* _tmp2_ = NULL;
	GtkTextIter _tmp3_ = {0};
	GtkTextIter _tmp4_ = {0};
	g_return_if_fail (self != NULL);
	journal_editor_getStartIter (self, &_tmp0_);
	startIter = _tmp0_;
	journal_editor_getEndIter (self, &_tmp1_);
	endIter = _tmp1_;
	_tmp2_ = self->priv->_buffer;
	_tmp3_ = startIter;
	_tmp4_ = endIter;
	gtk_text_buffer_remove_all_tags (_tmp2_, &_tmp3_, &_tmp4_);
}


void journal_editor_undo (JournalEditor* self) {
	GeeArrayList* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	Action* undo = NULL;
	GeeArrayList* _tmp3_ = NULL;
	gpointer _tmp4_ = NULL;
	Action* redo = NULL;
	Action* _tmp5_ = NULL;
	Action* _tmp6_ = NULL;
	GeeArrayList* _tmp7_ = NULL;
	Action* _tmp8_ = NULL;
	GeeArrayList* _tmp9_ = NULL;
	Action* _tmp10_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->undos;
	_tmp1_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == 0) {
		zystem_debug ("Nothing to undo");
		return;
	}
	journal_editor_disconnectSignals (self);
	_tmp3_ = self->priv->undos;
	_tmp4_ = gee_list_last ((GeeList*) _tmp3_);
	undo = (Action*) _tmp4_;
	_tmp5_ = undo;
	_tmp6_ = journal_editor_doAction (self, _tmp5_);
	redo = _tmp6_;
	_tmp7_ = self->priv->redos;
	_tmp8_ = redo;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, _tmp8_);
	_tmp9_ = self->priv->undos;
	_tmp10_ = undo;
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp9_, _tmp10_);
	journal_editor_connectSignals (self);
	_action_unref0 (redo);
	_action_unref0 (undo);
}


static gpointer _action_ref0 (gpointer self) {
	return self ? action_ref (self) : NULL;
}


Action* journal_editor_doAction (JournalEditor* self, Action* action) {
	Action* result = NULL;
	Action* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	Action* _tmp44_ = NULL;
	Action* _tmp45_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (action != NULL, NULL);
	_tmp0_ = action;
	_tmp1_ = action_get_action (_tmp0_);
	_tmp2_ = _tmp1_;
	if (g_strcmp0 (_tmp2_, "delete") == 0) {
		GtkTextIter start = {0};
		Action* _tmp3_ = NULL;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		GtkTextIter _tmp6_ = {0};
		GtkTextIter end = {0};
		Action* _tmp7_ = NULL;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		Action* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		GtkTextIter _tmp15_ = {0};
		GtkTextBuffer* _tmp16_ = NULL;
		Action* _tmp17_ = NULL;
		_tmp3_ = action;
		_tmp4_ = action_get_offset (_tmp3_);
		_tmp5_ = _tmp4_;
		journal_editor_getIterAtOffset (self, _tmp5_, &_tmp6_);
		start = _tmp6_;
		_tmp7_ = action;
		_tmp8_ = action_get_offset (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = action;
		_tmp11_ = action_get_text (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = strlen (_tmp12_);
		_tmp14_ = _tmp13_;
		journal_editor_getIterAtOffset (self, _tmp9_ + _tmp14_, &_tmp15_);
		end = _tmp15_;
		_tmp16_ = self->priv->_buffer;
		gtk_text_buffer_delete (_tmp16_, &start, &end);
		_tmp17_ = action;
		action_set_action (_tmp17_, "insert");
	} else {
		Action* _tmp18_ = NULL;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_ = NULL;
		_tmp18_ = action;
		_tmp19_ = action_get_action (_tmp18_);
		_tmp20_ = _tmp19_;
		if (g_strcmp0 (_tmp20_, "insert") == 0) {
			GtkTextIter start = {0};
			Action* _tmp21_ = NULL;
			gint _tmp22_ = 0;
			gint _tmp23_ = 0;
			GtkTextIter _tmp24_ = {0};
			GtkTextIter end = {0};
			Action* _tmp25_ = NULL;
			gint _tmp26_ = 0;
			gint _tmp27_ = 0;
			Action* _tmp28_ = NULL;
			const gchar* _tmp29_ = NULL;
			const gchar* _tmp30_ = NULL;
			gint _tmp31_ = 0;
			gint _tmp32_ = 0;
			GtkTextIter _tmp33_ = {0};
			GtkTextBuffer* _tmp34_ = NULL;
			Action* _tmp35_ = NULL;
			const gchar* _tmp36_ = NULL;
			const gchar* _tmp37_ = NULL;
			Action* _tmp38_ = NULL;
			const gchar* _tmp39_ = NULL;
			const gchar* _tmp40_ = NULL;
			gint _tmp41_ = 0;
			gint _tmp42_ = 0;
			Action* _tmp43_ = NULL;
			_tmp21_ = action;
			_tmp22_ = action_get_offset (_tmp21_);
			_tmp23_ = _tmp22_;
			journal_editor_getIterAtOffset (self, _tmp23_, &_tmp24_);
			start = _tmp24_;
			_tmp25_ = action;
			_tmp26_ = action_get_offset (_tmp25_);
			_tmp27_ = _tmp26_;
			_tmp28_ = action;
			_tmp29_ = action_get_text (_tmp28_);
			_tmp30_ = _tmp29_;
			_tmp31_ = strlen (_tmp30_);
			_tmp32_ = _tmp31_;
			journal_editor_getIterAtOffset (self, _tmp27_ + _tmp32_, &_tmp33_);
			end = _tmp33_;
			_tmp34_ = self->priv->_buffer;
			_tmp35_ = action;
			_tmp36_ = action_get_text (_tmp35_);
			_tmp37_ = _tmp36_;
			_tmp38_ = action;
			_tmp39_ = action_get_text (_tmp38_);
			_tmp40_ = _tmp39_;
			_tmp41_ = strlen (_tmp40_);
			_tmp42_ = _tmp41_;
			gtk_text_buffer_insert (_tmp34_, &start, _tmp37_, _tmp42_);
			_tmp43_ = action;
			action_set_action (_tmp43_, "delete");
		}
	}
	_tmp44_ = action;
	_tmp45_ = _action_ref0 (_tmp44_);
	result = _tmp45_;
	return result;
}


void journal_editor_redo (JournalEditor* self) {
	GeeArrayList* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	Action* redo = NULL;
	GeeArrayList* _tmp3_ = NULL;
	gpointer _tmp4_ = NULL;
	Action* undo = NULL;
	Action* _tmp5_ = NULL;
	Action* _tmp6_ = NULL;
	GeeArrayList* _tmp7_ = NULL;
	Action* _tmp8_ = NULL;
	GeeArrayList* _tmp9_ = NULL;
	Action* _tmp10_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->redos;
	_tmp1_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == 0) {
		zystem_debug ("Nothing to redo");
		return;
	}
	journal_editor_disconnectSignals (self);
	_tmp3_ = self->priv->redos;
	_tmp4_ = gee_list_last ((GeeList*) _tmp3_);
	redo = (Action*) _tmp4_;
	_tmp5_ = redo;
	_tmp6_ = journal_editor_doAction (self, _tmp5_);
	undo = _tmp6_;
	_tmp7_ = self->priv->undos;
	_tmp8_ = undo;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, _tmp8_);
	_tmp9_ = self->priv->redos;
	_tmp10_ = redo;
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp9_, _tmp10_);
	journal_editor_connectSignals (self);
	journal_editor_highlight (self);
	_action_unref0 (undo);
	_action_unref0 (redo);
}


static void journal_editor_onInsertText (JournalEditor* self, GtkTextIter* iter, const gchar* text, gint length) {
	Action* cmd = NULL;
	gint _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
	Action* _tmp2_ = NULL;
	GeeArrayList* _tmp3_ = NULL;
	GeeArrayList* _tmp4_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (iter != NULL);
	g_return_if_fail (text != NULL);
	journal_editor_highlight (self);
	_tmp0_ = gtk_text_iter_get_offset (iter);
	_tmp1_ = text;
	_tmp2_ = action_new ("delete", _tmp0_, _tmp1_);
	cmd = _tmp2_;
	_tmp3_ = self->priv->undos;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp3_, cmd);
	_tmp4_ = self->priv->redos;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp4_);
	_action_unref0 (cmd);
}


static void journal_editor_onDeleteRange (JournalEditor* self, GtkTextIter* startIter, GtkTextIter* endIter) {
	gchar* text = NULL;
	GtkTextBuffer* _tmp0_ = NULL;
	GtkTextIter _tmp1_ = {0};
	GtkTextIter _tmp2_ = {0};
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	Action* cmd = NULL;
	gint _tmp6_ = 0;
	Action* _tmp7_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (startIter != NULL);
	g_return_if_fail (endIter != NULL);
	zystem_debug ("In onDeleteRange()");
	journal_editor_highlight (self);
	_tmp0_ = self->priv->_buffer;
	_tmp1_ = *startIter;
	_tmp2_ = *endIter;
	_tmp3_ = gtk_text_buffer_get_text (_tmp0_, &_tmp1_, &_tmp2_, FALSE);
	text = _tmp3_;
	_tmp4_ = g_strconcat ("Text was: ", text, NULL);
	_tmp5_ = _tmp4_;
	zystem_debug (_tmp5_);
	_g_free0 (_tmp5_);
	_tmp6_ = gtk_text_iter_get_offset (startIter);
	_tmp7_ = action_new ("insert", _tmp6_, text);
	cmd = _tmp7_;
	journal_editor_addUndo (self, cmd);
	_action_unref0 (cmd);
	_g_free0 (text);
}


static void journal_editor_addUndo (JournalEditor* self, Action* cmd) {
	GeeArrayList* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	GeeArrayList* _tmp4_ = NULL;
	Action* _tmp5_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cmd != NULL);
	_tmp0_ = self->priv->undos;
	_tmp1_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->undoMax;
	if (_tmp2_ >= _tmp3_) {
	}
	_tmp4_ = self->priv->undos;
	_tmp5_ = cmd;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, _tmp5_);
}


static void __lambda4_ (JournalEditor* self, GtkTextIter* iter, const gchar* text, gint length) {
	GtkTextIter _tmp0_ = {0};
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	g_return_if_fail (iter != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = *iter;
	_tmp1_ = text;
	_tmp2_ = length;
	journal_editor_onInsertText (self, &_tmp0_, _tmp1_, _tmp2_);
}


static void ___lambda4__gtk_text_buffer_insert_text (GtkTextBuffer* _sender, GtkTextIter* pos, const gchar* new_text, gint new_text_length, gpointer self) {
	__lambda4_ ((JournalEditor*) self, pos, new_text, new_text_length);
}


static void __lambda5_ (JournalEditor* self, GtkTextIter* startIter, GtkTextIter* endIter) {
	GtkTextIter _tmp0_ = {0};
	GtkTextIter _tmp1_ = {0};
	g_return_if_fail (startIter != NULL);
	g_return_if_fail (endIter != NULL);
	_tmp0_ = *startIter;
	_tmp1_ = *endIter;
	journal_editor_onDeleteRange (self, &_tmp0_, &_tmp1_);
}


static void ___lambda5__gtk_text_buffer_delete_range (GtkTextBuffer* _sender, GtkTextIter* start, GtkTextIter* end, gpointer self) {
	__lambda5_ ((JournalEditor*) self, start, end);
}


static void journal_editor_connectSignals (JournalEditor* self) {
	GtkTextBuffer* _tmp0_ = NULL;
	gulong _tmp1_ = 0UL;
	GtkTextBuffer* _tmp2_ = NULL;
	gulong _tmp3_ = 0UL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_buffer;
	_tmp1_ = g_signal_connect_object (_tmp0_, "insert-text", (GCallback) ___lambda4__gtk_text_buffer_insert_text, self, 0);
	self->priv->onInsertConnection = _tmp1_;
	_tmp2_ = self->priv->_buffer;
	_tmp3_ = g_signal_connect_object (_tmp2_, "delete-range", (GCallback) ___lambda5__gtk_text_buffer_delete_range, self, 0);
	self->priv->onDeleteConnection = _tmp3_;
}


static void journal_editor_disconnectSignals (JournalEditor* self) {
	GtkTextBuffer* _tmp0_ = NULL;
	gulong _tmp1_ = 0UL;
	GtkTextBuffer* _tmp2_ = NULL;
	gulong _tmp3_ = 0UL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_buffer;
	_tmp1_ = self->priv->onInsertConnection;
	g_signal_handler_disconnect ((GObject*) _tmp0_, _tmp1_);
	_tmp2_ = self->priv->_buffer;
	_tmp3_ = self->priv->onDeleteConnection;
	g_signal_handler_disconnect ((GObject*) _tmp2_, _tmp3_);
}


GtkTextBuffer* journal_editor_get_buffer (JournalEditor* self) {
	GtkTextBuffer* result;
	GtkTextBuffer* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_buffer;
	result = _tmp0_;
	return result;
}


static void journal_editor_set_buffer (JournalEditor* self, GtkTextBuffer* value) {
	GtkTextBuffer* _tmp0_ = NULL;
	GtkTextBuffer* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_buffer);
	self->priv->_buffer = _tmp1_;
	g_object_notify ((GObject *) self, "buffer");
}


static void journal_editor_class_init (JournalEditorClass * klass) {
	journal_editor_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (JournalEditorPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_journal_editor_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_journal_editor_set_property;
	G_OBJECT_CLASS (klass)->finalize = journal_editor_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), JOURNAL_EDITOR_BUFFER, g_param_spec_object ("buffer", "buffer", "buffer", gtk_text_buffer_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void journal_editor_instance_init (JournalEditor * self) {
	self->priv = JOURNAL_EDITOR_GET_PRIVATE (self);
}


static void journal_editor_finalize (GObject* obj) {
	JournalEditor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_JOURNAL_EDITOR, JournalEditor);
	_g_object_unref0 (self->priv->_buffer);
	_g_object_unref0 (self->priv->undos);
	_g_object_unref0 (self->priv->redos);
	G_OBJECT_CLASS (journal_editor_parent_class)->finalize (obj);
}


GType journal_editor_get_type (void) {
	static volatile gsize journal_editor_type_id__volatile = 0;
	if (g_once_init_enter (&journal_editor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (JournalEditorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) journal_editor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (JournalEditor), 0, (GInstanceInitFunc) journal_editor_instance_init, NULL };
		GType journal_editor_type_id;
		journal_editor_type_id = g_type_register_static (G_TYPE_OBJECT, "JournalEditor", &g_define_type_info, 0);
		g_once_init_leave (&journal_editor_type_id__volatile, journal_editor_type_id);
	}
	return journal_editor_type_id__volatile;
}


static void _vala_journal_editor_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	JournalEditor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_JOURNAL_EDITOR, JournalEditor);
	switch (property_id) {
		case JOURNAL_EDITOR_BUFFER:
		g_value_set_object (value, journal_editor_get_buffer (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_journal_editor_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	JournalEditor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_JOURNAL_EDITOR, JournalEditor);
	switch (property_id) {
		case JOURNAL_EDITOR_BUFFER:
		journal_editor_set_buffer (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


Action* action_construct (GType object_type, const gchar* action, gint offset, const gchar* text) {
	Action* self = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	g_return_val_if_fail (action != NULL, NULL);
	g_return_val_if_fail (text != NULL, NULL);
	self = (Action*) g_type_create_instance (object_type);
	_tmp0_ = action;
	action_set_action (self, _tmp0_);
	_tmp1_ = text;
	action_set_text (self, _tmp1_);
	_tmp2_ = offset;
	action_set_offset (self, _tmp2_);
	return self;
}


Action* action_new (const gchar* action, gint offset, const gchar* text) {
	return action_construct (TYPE_ACTION, action, offset, text);
}


const gchar* action_get_action (Action* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_action;
	result = _tmp0_;
	return result;
}


void action_set_action (Action* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_action);
	self->priv->_action = _tmp1_;
}


const gchar* action_get_text (Action* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_text;
	result = _tmp0_;
	return result;
}


void action_set_text (Action* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_text);
	self->priv->_text = _tmp1_;
}


gint action_get_offset (Action* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_offset;
	result = _tmp0_;
	return result;
}


void action_set_offset (Action* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_offset = _tmp0_;
}


static void value_action_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_action_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		action_unref (value->data[0].v_pointer);
	}
}


static void value_action_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = action_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_action_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_action_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		Action* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = action_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_action_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Action** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = action_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_action (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecAction* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_ACTION), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_action (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ACTION), NULL);
	return value->data[0].v_pointer;
}


void value_set_action (GValue* value, gpointer v_object) {
	Action* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ACTION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ACTION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		action_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		action_unref (old);
	}
}


void value_take_action (GValue* value, gpointer v_object) {
	Action* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ACTION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ACTION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		action_unref (old);
	}
}


static void action_class_init (ActionClass * klass) {
	action_parent_class = g_type_class_peek_parent (klass);
	((ActionClass *) klass)->finalize = action_finalize;
	g_type_class_add_private (klass, sizeof (ActionPrivate));
}


static void action_instance_init (Action * self) {
	self->priv = ACTION_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void action_finalize (Action* obj) {
	Action * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ACTION, Action);
	g_signal_handlers_destroy (self);
	_g_free0 (self->priv->_action);
	_g_free0 (self->priv->_text);
}


GType action_get_type (void) {
	static volatile gsize action_type_id__volatile = 0;
	if (g_once_init_enter (&action_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_action_init, value_action_free_value, value_action_copy_value, value_action_peek_pointer, "p", value_action_collect_value, "p", value_action_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Action), 0, (GInstanceInitFunc) action_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType action_type_id;
		action_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Action", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&action_type_id__volatile, action_type_id);
	}
	return action_type_id__volatile;
}


gpointer action_ref (gpointer instance) {
	Action* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void action_unref (gpointer instance) {
	Action* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		ACTION_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



