/* JournalEntry.c generated by valac 0.30.0, the Vala compiler
 * generated from JournalEntry.vala, do not modify */

/*
 * DayJournal
 *
 * Copyright (C) 2013 Zach Burnham <thejambi@gmail.com>
 *
 * DayJournal is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * DayJournal is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <glib/gstdio.h>


#define TYPE_JOURNAL_ENTRY (journal_entry_get_type ())
#define JOURNAL_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_JOURNAL_ENTRY, JournalEntry))
#define JOURNAL_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_JOURNAL_ENTRY, JournalEntryClass))
#define IS_JOURNAL_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_JOURNAL_ENTRY))
#define IS_JOURNAL_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_JOURNAL_ENTRY))
#define JOURNAL_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_JOURNAL_ENTRY, JournalEntryClass))

typedef struct _JournalEntry JournalEntry;
typedef struct _JournalEntryClass JournalEntryClass;
typedef struct _JournalEntryPrivate JournalEntryPrivate;

#define TYPE_ENTRY_IMAGE_ANCHORS (entry_image_anchors_get_type ())
#define ENTRY_IMAGE_ANCHORS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ENTRY_IMAGE_ANCHORS, EntryImageAnchors))
#define ENTRY_IMAGE_ANCHORS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ENTRY_IMAGE_ANCHORS, EntryImageAnchorsClass))
#define IS_ENTRY_IMAGE_ANCHORS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ENTRY_IMAGE_ANCHORS))
#define IS_ENTRY_IMAGE_ANCHORS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ENTRY_IMAGE_ANCHORS))
#define ENTRY_IMAGE_ANCHORS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ENTRY_IMAGE_ANCHORS, EntryImageAnchorsClass))

typedef struct _EntryImageAnchors EntryImageAnchors;
typedef struct _EntryImageAnchorsClass EntryImageAnchorsClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _journal_entry_saveEntryFileData journal_entry_saveEntryFileData;
typedef struct _journal_entry_saveFileContentsAsyncData journal_entry_saveFileContentsAsyncData;

struct _JournalEntry {
	GObject parent_instance;
	JournalEntryPrivate * priv;
};

struct _JournalEntryClass {
	GObjectClass parent_class;
};

struct _JournalEntryPrivate {
	gchar* yearDirPath;
	gchar* _archiveRelativeMonthPath;
	gchar* _monthDirPath;
	gchar* _filePath;
	GFile* entryFile;
	gint saveCounter;
	EntryImageAnchors* images;
	gboolean _fileSavingLock;
	gboolean _fileSaveRequested;
	GDateTime* _dateTime;
};

struct _journal_entry_saveEntryFileData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	JournalEntry* self;
	GtkTextBuffer* buffer;
	GFile* monthDir;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	gchar* entryText;
	GtkTextBuffer* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GFile* _tmp5_;
	gboolean _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	GError * _inner_error_;
};

struct _journal_entry_saveFileContentsAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	JournalEntry* self;
	gchar* entryText;
	GFile* _tmp0_;
	const gchar* _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
	GError * _inner_error_;
};


static gpointer journal_entry_parent_class = NULL;

GType journal_entry_get_type (void) G_GNUC_CONST;
GType entry_image_anchors_get_type (void) G_GNUC_CONST;
#define JOURNAL_ENTRY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_JOURNAL_ENTRY, JournalEntryPrivate))
enum  {
	JOURNAL_ENTRY_DUMMY_PROPERTY,
	JOURNAL_ENTRY_ARCHIVE_RELATIVE_MONTH_PATH,
	JOURNAL_ENTRY_MONTH_DIR_PATH,
	JOURNAL_ENTRY_FILE_PATH,
	JOURNAL_ENTRY_FILE_SAVING_LOCK,
	JOURNAL_ENTRY_FILE_SAVE_REQUESTED,
	JOURNAL_ENTRY_DATE_TIME,
	JOURNAL_ENTRY_YEAR,
	JOURNAL_ENTRY_MONTH,
	JOURNAL_ENTRY_DAY
};
JournalEntry* journal_entry_new (gint year, gint month, gint day);
JournalEntry* journal_entry_construct (GType object_type, gint year, gint month, gint day);
static void journal_entry_set_dateTime (JournalEntry* self, GDateTime* value);
static gchar* journal_entry_getDayJournalDirectory (JournalEntry* self);
static void journal_entry_set_monthDirPath (JournalEntry* self, const gchar* value);
const gchar* journal_entry_get_monthDirPath (JournalEntry* self);
gchar* journal_entry_getDayString (JournalEntry* self);
static void journal_entry_set_filePath (JournalEntry* self, const gchar* value);
const gchar* journal_entry_get_filePath (JournalEntry* self);
static void journal_entry_set_archiveRelativeMonthPath (JournalEntry* self, const gchar* value);
EntryImageAnchors* entry_image_anchors_new (void);
EntryImageAnchors* entry_image_anchors_construct (GType object_type);
void journal_entry_addImage (JournalEntry* self, const gchar* relativePath, const gchar* fullPath, GtkImage* img, GtkTextChildAnchor* anchor, GtkTextBuffer* buffer);
void entry_image_anchors_add (EntryImageAnchors* self, const gchar* relativePath, const gchar* fullPath, GtkImage* img, GtkTextChildAnchor* anchor, GtkTextBuffer* buffer);
gchar* journal_entry_replaceImagesWithTags (JournalEntry* self, GtkTextBuffer* buffer);
gchar* entry_image_anchors_replaceImagesWithTags (EntryImageAnchors* self, GtkTextBuffer* buffer);
void zystem_debug (const gchar* s);
const gchar* user_data_get_djDirPath (void);
gchar* journal_entry_getFileContents (JournalEntry* self);
static void journal_entry_saveEntryFile_data_free (gpointer _data);
void journal_entry_saveEntryFile (JournalEntry* self, GtkTextBuffer* buffer, GAsyncReadyCallback _callback_, gpointer _user_data_);
void journal_entry_saveEntryFile_finish (JournalEntry* self, GAsyncResult* _res_, GError** error);
static gboolean journal_entry_saveEntryFile_co (journal_entry_saveEntryFileData* _data_);
static void journal_entry_removeEntryFile (JournalEntry* self);
static void journal_entry_saveFileContentsAsync (JournalEntry* self, const gchar* entryText, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void journal_entry_saveFileContentsAsync_finish (JournalEntry* self, GAsyncResult* _res_, GError** error);
static void journal_entry_saveEntryFile_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void journal_entry_saveFileContentsAsync_data_free (gpointer _data);
static gboolean journal_entry_saveFileContentsAsync_co (journal_entry_saveFileContentsAsyncData* _data_);
static void journal_entry_saveFileContentsAsync_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
void journal_entry_saveEntryFileNonAsync (JournalEntry* self, const gchar* entryText, GError** error);
static void journal_entry_saveFileContents (JournalEntry* self, const gchar* entryText, GError** error);
void journal_entry_createPath (JournalEntry* self);
static void journal_entry_removeMonthDirIfEmpty (JournalEntry* self, GError** error);
gboolean file_utility_isDirectoryEmpty (const gchar* dirPath);
static void journal_entry_removeYearDirIfEmpty (JournalEntry* self, GError** error);
gchar* journal_entry_getEntryDateHeading (JournalEntry* self);
GDateTime* journal_entry_get_dateTime (JournalEntry* self);
gint journal_entry_get_day (JournalEntry* self);
const gchar* journal_entry_get_archiveRelativeMonthPath (JournalEntry* self);
gboolean journal_entry_get_fileSavingLock (JournalEntry* self);
static void journal_entry_set_fileSavingLock (JournalEntry* self, gboolean value);
gboolean journal_entry_get_fileSaveRequested (JournalEntry* self);
static void journal_entry_set_fileSaveRequested (JournalEntry* self, gboolean value);
gint journal_entry_get_year (JournalEntry* self);
gint journal_entry_get_month (JournalEntry* self);
static void journal_entry_finalize (GObject* obj);
static void _vala_journal_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_journal_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * Constructor.
 */
JournalEntry* journal_entry_construct (GType object_type, gint year, gint month, gint day) {
	JournalEntry * self = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	GDateTime* _tmp3_ = NULL;
	GDateTime* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	gint _tmp12_ = 0;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	const gchar* _tmp17_ = NULL;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
	gchar* _tmp20_ = NULL;
	gchar* _tmp21_ = NULL;
	gchar* _tmp22_ = NULL;
	gchar* _tmp23_ = NULL;
	const gchar* _tmp24_ = NULL;
	GFile* _tmp25_ = NULL;
	gint _tmp26_ = 0;
	gchar* _tmp27_ = NULL;
	gchar* _tmp28_ = NULL;
	gint _tmp29_ = 0;
	gchar* _tmp30_ = NULL;
	gchar* _tmp31_ = NULL;
	gchar* _tmp32_ = NULL;
	gchar* _tmp33_ = NULL;
	EntryImageAnchors* _tmp34_ = NULL;
	self = (JournalEntry*) g_object_new (object_type, NULL);
	_tmp0_ = year;
	_tmp1_ = month;
	_tmp2_ = day;
	_tmp3_ = g_date_time_new_local (_tmp0_, _tmp1_, _tmp2_, 0, 0, (gdouble) 0);
	_tmp4_ = _tmp3_;
	journal_entry_set_dateTime (self, _tmp4_);
	_g_date_time_unref0 (_tmp4_);
	_tmp5_ = journal_entry_getDayJournalDirectory (self);
	_tmp6_ = _tmp5_;
	_tmp7_ = year;
	_tmp8_ = g_strdup_printf ("%04i", _tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_build_path (G_DIR_SEPARATOR_S, _tmp6_, _tmp9_, NULL);
	_g_free0 (self->priv->yearDirPath);
	self->priv->yearDirPath = _tmp10_;
	_g_free0 (_tmp9_);
	_g_free0 (_tmp6_);
	_tmp11_ = self->priv->yearDirPath;
	_tmp12_ = month;
	_tmp13_ = g_strdup_printf ("%02i", _tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = g_build_path (G_DIR_SEPARATOR_S, _tmp11_, _tmp14_, NULL);
	_tmp16_ = _tmp15_;
	journal_entry_set_monthDirPath (self, _tmp16_);
	_g_free0 (_tmp16_);
	_g_free0 (_tmp14_);
	_tmp17_ = self->priv->_monthDirPath;
	_tmp18_ = journal_entry_getDayString (self);
	_tmp19_ = _tmp18_;
	_tmp20_ = g_strconcat (_tmp19_, ".txt", NULL);
	_tmp21_ = _tmp20_;
	_tmp22_ = g_build_path (G_DIR_SEPARATOR_S, _tmp17_, _tmp21_, NULL);
	_tmp23_ = _tmp22_;
	journal_entry_set_filePath (self, _tmp23_);
	_g_free0 (_tmp23_);
	_g_free0 (_tmp21_);
	_g_free0 (_tmp19_);
	_tmp24_ = self->priv->_filePath;
	_tmp25_ = g_file_new_for_path (_tmp24_);
	_g_object_unref0 (self->priv->entryFile);
	self->priv->entryFile = _tmp25_;
	_tmp26_ = year;
	_tmp27_ = g_strdup_printf ("%04i", _tmp26_);
	_tmp28_ = _tmp27_;
	_tmp29_ = month;
	_tmp30_ = g_strdup_printf ("%02i", _tmp29_);
	_tmp31_ = _tmp30_;
	_tmp32_ = g_build_path (G_DIR_SEPARATOR_S, "..", _tmp28_, _tmp31_, NULL);
	_tmp33_ = _tmp32_;
	journal_entry_set_archiveRelativeMonthPath (self, _tmp33_);
	_g_free0 (_tmp33_);
	_g_free0 (_tmp31_);
	_g_free0 (_tmp28_);
	self->priv->saveCounter = 0;
	_tmp34_ = entry_image_anchors_new ();
	_g_object_unref0 (self->priv->images);
	self->priv->images = _tmp34_;
	return self;
}


JournalEntry* journal_entry_new (gint year, gint month, gint day) {
	return journal_entry_construct (TYPE_JOURNAL_ENTRY, year, month, day);
}


void journal_entry_addImage (JournalEntry* self, const gchar* relativePath, const gchar* fullPath, GtkImage* img, GtkTextChildAnchor* anchor, GtkTextBuffer* buffer) {
	EntryImageAnchors* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	GtkImage* _tmp3_ = NULL;
	GtkTextChildAnchor* _tmp4_ = NULL;
	GtkTextBuffer* _tmp5_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (relativePath != NULL);
	g_return_if_fail (fullPath != NULL);
	g_return_if_fail (img != NULL);
	g_return_if_fail (anchor != NULL);
	g_return_if_fail (buffer != NULL);
	_tmp0_ = self->priv->images;
	_tmp1_ = relativePath;
	_tmp2_ = fullPath;
	_tmp3_ = img;
	_tmp4_ = anchor;
	_tmp5_ = buffer;
	entry_image_anchors_add (_tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_);
}


gchar* journal_entry_replaceImagesWithTags (JournalEntry* self, GtkTextBuffer* buffer) {
	gchar* result = NULL;
	gchar* txt = NULL;
	EntryImageAnchors* _tmp0_ = NULL;
	GtkTextBuffer* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (buffer != NULL, NULL);
	_tmp0_ = self->priv->images;
	_tmp1_ = buffer;
	_tmp2_ = entry_image_anchors_replaceImagesWithTags (_tmp0_, _tmp1_);
	txt = _tmp2_;
	_tmp3_ = g_strconcat ("Got replaced text: ", txt, NULL);
	_tmp4_ = _tmp3_;
	zystem_debug (_tmp4_);
	_g_free0 (_tmp4_);
	result = txt;
	return result;
}


static gchar* journal_entry_getDayJournalDirectory (JournalEntry* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = user_data_get_djDirPath ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup (_tmp1_);
	result = _tmp2_;
	return result;
}


gchar* journal_entry_getFileContents (JournalEntry* self) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		gchar* contents = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		_tmp0_ = self->priv->_filePath;
		g_file_get_contents (_tmp0_, &_tmp1_, NULL, &_inner_error_);
		_g_free0 (contents);
		contents = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (contents);
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch7_g_file_error;
			}
			_g_free0 (contents);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = contents;
		return result;
	}
	goto __finally7;
	__catch7_g_file_error:
	{
		GError* e = NULL;
		gchar* _tmp2_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = g_strdup ("");
		result = _tmp2_;
		_g_error_free0 (e);
		return result;
	}
	__finally7:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return NULL;
}


static void journal_entry_saveEntryFile_data_free (gpointer _data) {
	journal_entry_saveEntryFileData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->buffer);
	_g_object_unref0 (_data_->self);
	g_slice_free (journal_entry_saveEntryFileData, _data_);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void journal_entry_saveEntryFile (JournalEntry* self, GtkTextBuffer* buffer, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	journal_entry_saveEntryFileData* _data_;
	JournalEntry* _tmp0_ = NULL;
	GtkTextBuffer* _tmp1_ = NULL;
	GtkTextBuffer* _tmp2_ = NULL;
	_data_ = g_slice_new0 (journal_entry_saveEntryFileData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, journal_entry_saveEntryFile);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, journal_entry_saveEntryFile_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = buffer;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_g_object_unref0 (_data_->buffer);
	_data_->buffer = _tmp2_;
	journal_entry_saveEntryFile_co (_data_);
}


void journal_entry_saveEntryFile_finish (JournalEntry* self, GAsyncResult* _res_, GError** error) {
	journal_entry_saveEntryFileData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void journal_entry_saveEntryFile_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	journal_entry_saveEntryFileData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	journal_entry_saveEntryFile_co (_data_);
}


static gboolean journal_entry_saveEntryFile_co (journal_entry_saveEntryFileData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = NULL;
	_data_->_tmp0_ = _data_->self->priv->_monthDirPath;
	_data_->_tmp1_ = NULL;
	_data_->_tmp1_ = g_file_new_for_path (_data_->_tmp0_);
	_data_->monthDir = _data_->_tmp1_;
	_data_->_tmp2_ = NULL;
	_data_->_tmp2_ = _data_->buffer;
	_data_->_tmp3_ = NULL;
	_data_->_tmp3_ = journal_entry_replaceImagesWithTags (_data_->self, _data_->_tmp2_);
	_data_->entryText = _data_->_tmp3_;
	_data_->_tmp4_ = NULL;
	_data_->_tmp4_ = _data_->entryText;
	if (g_strcmp0 (_data_->_tmp4_, "") == 0) {
		journal_entry_removeEntryFile (_data_->self);
	} else {
		_data_->_tmp5_ = NULL;
		_data_->_tmp5_ = _data_->monthDir;
		_data_->_tmp6_ = FALSE;
		_data_->_tmp6_ = g_file_query_exists (_data_->_tmp5_, NULL);
		if (!_data_->_tmp6_) {
			_data_->_tmp7_ = NULL;
			_data_->_tmp7_ = _data_->self->priv->_monthDirPath;
			g_mkdir_with_parents (_data_->_tmp7_, 0775);
		}
		_data_->_tmp8_ = NULL;
		_data_->_tmp8_ = _data_->entryText;
		_data_->_state_ = 1;
		journal_entry_saveFileContentsAsync (_data_->self, _data_->_tmp8_, journal_entry_saveEntryFile_ready, _data_);
		return FALSE;
		_state_1:
		journal_entry_saveFileContentsAsync_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
			g_error_free (_data_->_inner_error_);
			_g_free0 (_data_->entryText);
			_g_object_unref0 (_data_->monthDir);
			if (_data_->_state_ == 0) {
				g_simple_async_result_complete_in_idle (_data_->_async_result);
			} else {
				g_simple_async_result_complete (_data_->_async_result);
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	_g_free0 (_data_->entryText);
	_g_object_unref0 (_data_->monthDir);
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void journal_entry_saveFileContentsAsync_data_free (gpointer _data) {
	journal_entry_saveFileContentsAsyncData* _data_;
	_data_ = _data;
	_g_free0 (_data_->entryText);
	_g_object_unref0 (_data_->self);
	g_slice_free (journal_entry_saveFileContentsAsyncData, _data_);
}


static void journal_entry_saveFileContentsAsync (JournalEntry* self, const gchar* entryText, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	journal_entry_saveFileContentsAsyncData* _data_;
	JournalEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	_data_ = g_slice_new0 (journal_entry_saveFileContentsAsyncData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, journal_entry_saveFileContentsAsync);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, journal_entry_saveFileContentsAsync_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = entryText;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 (_data_->entryText);
	_data_->entryText = _tmp2_;
	journal_entry_saveFileContentsAsync_co (_data_);
}


static void journal_entry_saveFileContentsAsync_finish (JournalEntry* self, GAsyncResult* _res_, GError** error) {
	journal_entry_saveFileContentsAsyncData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static guint8* string_get_data (const gchar* self, int* result_length1) {
	guint8* result;
	guint8* res = NULL;
	gint res_length1 = 0;
	gint _res_size_ = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	guint8* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	guint8* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res_length1;
	_tmp3_ = res;
	_tmp3__length1 = res_length1;
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp3__length1;
	if (result_length1) {
		*result_length1 = _tmp4__length1;
	}
	result = _tmp4_;
	return result;
}


static void journal_entry_saveFileContentsAsync_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	journal_entry_saveFileContentsAsyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	journal_entry_saveFileContentsAsync_co (_data_);
}


static gboolean journal_entry_saveFileContentsAsync_co (journal_entry_saveFileContentsAsyncData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = NULL;
	_data_->_tmp0_ = _data_->self->priv->entryFile;
	_data_->_tmp1_ = NULL;
	_data_->_tmp1_ = _data_->entryText;
	_data_->_tmp2_ = NULL;
	_data_->_tmp2__length1 = 0;
	_data_->_tmp2_ = string_get_data (_data_->_tmp1_, &_data_->_tmp2__length1);
	_data_->_tmp3_ = NULL;
	_data_->_tmp3__length1 = 0;
	_data_->_tmp3_ = _data_->_tmp2_;
	_data_->_tmp3__length1 = _data_->_tmp2__length1;
	_data_->_state_ = 1;
	g_file_replace_contents_async (_data_->_tmp0_, _data_->_tmp3_, (gsize) _data_->_tmp3__length1, NULL, FALSE, G_FILE_CREATE_NONE, NULL, journal_entry_saveFileContentsAsync_ready, _data_);
	return FALSE;
	_state_1:
	g_file_replace_contents_finish (_data_->_tmp0_, _data_->_res_, NULL, &_data_->_inner_error_);
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
		g_error_free (_data_->_inner_error_);
		if (_data_->_state_ == 0) {
			g_simple_async_result_complete_in_idle (_data_->_async_result);
		} else {
			g_simple_async_result_complete (_data_->_async_result);
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


void journal_entry_saveEntryFileNonAsync (JournalEntry* self, const gchar* entryText, GError** error) {
	GFile* monthDir = NULL;
	const gchar* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (entryText != NULL);
	_tmp0_ = self->priv->_monthDirPath;
	_tmp1_ = g_file_new_for_path (_tmp0_);
	monthDir = _tmp1_;
	_tmp2_ = entryText;
	if (g_strcmp0 (_tmp2_, "") == 0) {
		journal_entry_removeEntryFile (self);
	} else {
		GFile* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		const gchar* _tmp6_ = NULL;
		_tmp3_ = monthDir;
		_tmp4_ = g_file_query_exists (_tmp3_, NULL);
		if (!_tmp4_) {
			const gchar* _tmp5_ = NULL;
			_tmp5_ = self->priv->_monthDirPath;
			g_mkdir_with_parents (_tmp5_, 0775);
		}
		_tmp6_ = entryText;
		journal_entry_saveFileContents (self, _tmp6_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (monthDir);
			return;
		}
	}
	_g_object_unref0 (monthDir);
}


void journal_entry_createPath (JournalEntry* self) {
	GFile* monthDir = NULL;
	const gchar* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_monthDirPath;
	_tmp1_ = g_file_new_for_path (_tmp0_);
	monthDir = _tmp1_;
	_tmp2_ = monthDir;
	_tmp3_ = g_file_query_exists (_tmp2_, NULL);
	if (!_tmp3_) {
		const gchar* _tmp4_ = NULL;
		_tmp4_ = self->priv->_monthDirPath;
		g_mkdir_with_parents (_tmp4_, 0775);
	}
	_g_object_unref0 (monthDir);
}


static void journal_entry_saveFileContents (JournalEntry* self, const gchar* entryText, GError** error) {
	GFile* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	guint8* _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	guint8* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (entryText != NULL);
	_tmp0_ = self->priv->entryFile;
	_tmp1_ = entryText;
	_tmp2_ = string_get_data (_tmp1_, &_tmp2__length1);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp2__length1;
	g_file_replace_contents (_tmp0_, _tmp3_, (gsize) _tmp3__length1, NULL, FALSE, G_FILE_CREATE_NONE, NULL, NULL, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


static void journal_entry_removeEntryFile (JournalEntry* self) {
	GFile* file = NULL;
	const gchar* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	zystem_debug ("Should remove file");
	_tmp0_ = self->priv->_filePath;
	_tmp1_ = g_file_new_for_path (_tmp0_);
	file = _tmp1_;
	_tmp2_ = file;
	_tmp3_ = g_file_query_exists (_tmp2_, NULL);
	if (_tmp3_) {
		{
			GFile* _tmp4_ = NULL;
			_tmp4_ = file;
			g_file_delete (_tmp4_, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch8_g_error;
			}
			journal_entry_removeMonthDirIfEmpty (self, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch8_g_error;
			}
		}
		goto __finally8;
		__catch8_g_error:
		{
			GError* e = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			zystem_debug ("There was an error removing the entry file");
			_g_error_free0 (e);
		}
		__finally8:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_object_unref0 (file);
}


/**
 * Remove the month directory for the entry if it is empty.
 */
static void journal_entry_removeMonthDirIfEmpty (JournalEntry* self, GError** error) {
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_monthDirPath;
	_tmp1_ = file_utility_isDirectoryEmpty (_tmp0_);
	if (_tmp1_) {
		GFile* monthDir = NULL;
		const gchar* _tmp2_ = NULL;
		GFile* _tmp3_ = NULL;
		GFile* _tmp4_ = NULL;
		_tmp2_ = self->priv->_monthDirPath;
		_tmp3_ = g_file_new_for_path (_tmp2_);
		monthDir = _tmp3_;
		_tmp4_ = monthDir;
		g_file_delete (_tmp4_, NULL, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (monthDir);
			return;
		}
		journal_entry_removeYearDirIfEmpty (self, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (monthDir);
			return;
		}
		_g_object_unref0 (monthDir);
	}
}


/**
 * Remove the year directory for the entry if it is empty.
 */
static void journal_entry_removeYearDirIfEmpty (JournalEntry* self, GError** error) {
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->yearDirPath;
	_tmp1_ = file_utility_isDirectoryEmpty (_tmp0_);
	if (_tmp1_) {
		GFile* yearDir = NULL;
		const gchar* _tmp2_ = NULL;
		GFile* _tmp3_ = NULL;
		GFile* _tmp4_ = NULL;
		_tmp2_ = self->priv->yearDirPath;
		_tmp3_ = g_file_new_for_path (_tmp2_);
		yearDir = _tmp3_;
		_tmp4_ = yearDir;
		g_file_delete (_tmp4_, NULL, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (yearDir);
			return;
		}
		_g_object_unref0 (yearDir);
	}
}


/**
 * 
 */
gchar* journal_entry_getEntryDateHeading (JournalEntry* self) {
	gchar* result = NULL;
	GDateTime* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_dateTime;
	_tmp1_ = g_date_time_format (_tmp0_, "%B %e, %Y\n\n");
	result = _tmp1_;
	return result;
}


gchar* journal_entry_getDayString (JournalEntry* self) {
	gchar* result = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gchar* _tmp2_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = journal_entry_get_day (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("%02i", _tmp1_);
	result = _tmp2_;
	return result;
}


const gchar* journal_entry_get_archiveRelativeMonthPath (JournalEntry* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_archiveRelativeMonthPath;
	result = _tmp0_;
	return result;
}


static void journal_entry_set_archiveRelativeMonthPath (JournalEntry* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_archiveRelativeMonthPath);
	self->priv->_archiveRelativeMonthPath = _tmp1_;
	g_object_notify ((GObject *) self, "archiveRelativeMonthPath");
}


const gchar* journal_entry_get_monthDirPath (JournalEntry* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_monthDirPath;
	result = _tmp0_;
	return result;
}


static void journal_entry_set_monthDirPath (JournalEntry* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_monthDirPath);
	self->priv->_monthDirPath = _tmp1_;
	g_object_notify ((GObject *) self, "monthDirPath");
}


const gchar* journal_entry_get_filePath (JournalEntry* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_filePath;
	result = _tmp0_;
	return result;
}


static void journal_entry_set_filePath (JournalEntry* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_filePath);
	self->priv->_filePath = _tmp1_;
	g_object_notify ((GObject *) self, "filePath");
}


gboolean journal_entry_get_fileSavingLock (JournalEntry* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_fileSavingLock;
	result = _tmp0_;
	return result;
}


static void journal_entry_set_fileSavingLock (JournalEntry* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_fileSavingLock = _tmp0_;
	g_object_notify ((GObject *) self, "fileSavingLock");
}


gboolean journal_entry_get_fileSaveRequested (JournalEntry* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_fileSaveRequested;
	result = _tmp0_;
	return result;
}


static void journal_entry_set_fileSaveRequested (JournalEntry* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_fileSaveRequested = _tmp0_;
	g_object_notify ((GObject *) self, "fileSaveRequested");
}


GDateTime* journal_entry_get_dateTime (JournalEntry* self) {
	GDateTime* result;
	GDateTime* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_dateTime;
	result = _tmp0_;
	return result;
}


static gpointer _g_date_time_ref0 (gpointer self) {
	return self ? g_date_time_ref (self) : NULL;
}


static void journal_entry_set_dateTime (JournalEntry* self, GDateTime* value) {
	GDateTime* _tmp0_ = NULL;
	GDateTime* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_date_time_ref0 (_tmp0_);
	_g_date_time_unref0 (self->priv->_dateTime);
	self->priv->_dateTime = _tmp1_;
	g_object_notify ((GObject *) self, "dateTime");
}


gint journal_entry_get_year (JournalEntry* self) {
	gint result;
	GDateTime* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_dateTime;
	_tmp1_ = g_date_time_get_year (_tmp0_);
	result = _tmp1_;
	return result;
}


gint journal_entry_get_month (JournalEntry* self) {
	gint result;
	GDateTime* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_dateTime;
	_tmp1_ = g_date_time_get_month (_tmp0_);
	result = _tmp1_;
	return result;
}


gint journal_entry_get_day (JournalEntry* self) {
	gint result;
	GDateTime* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_dateTime;
	_tmp1_ = g_date_time_get_day_of_month (_tmp0_);
	result = _tmp1_;
	return result;
}


static void journal_entry_class_init (JournalEntryClass * klass) {
	journal_entry_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (JournalEntryPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_journal_entry_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_journal_entry_set_property;
	G_OBJECT_CLASS (klass)->finalize = journal_entry_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), JOURNAL_ENTRY_ARCHIVE_RELATIVE_MONTH_PATH, g_param_spec_string ("archiveRelativeMonthPath", "archiveRelativeMonthPath", "archiveRelativeMonthPath", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), JOURNAL_ENTRY_MONTH_DIR_PATH, g_param_spec_string ("monthDirPath", "monthDirPath", "monthDirPath", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), JOURNAL_ENTRY_FILE_PATH, g_param_spec_string ("filePath", "filePath", "filePath", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), JOURNAL_ENTRY_FILE_SAVING_LOCK, g_param_spec_boolean ("fileSavingLock", "fileSavingLock", "fileSavingLock", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), JOURNAL_ENTRY_FILE_SAVE_REQUESTED, g_param_spec_boolean ("fileSaveRequested", "fileSaveRequested", "fileSaveRequested", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), JOURNAL_ENTRY_DATE_TIME, g_param_spec_boxed ("dateTime", "dateTime", "dateTime", G_TYPE_DATE_TIME, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), JOURNAL_ENTRY_YEAR, g_param_spec_int ("year", "year", "year", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), JOURNAL_ENTRY_MONTH, g_param_spec_int ("month", "month", "month", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), JOURNAL_ENTRY_DAY, g_param_spec_int ("day", "day", "day", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void journal_entry_instance_init (JournalEntry * self) {
	self->priv = JOURNAL_ENTRY_GET_PRIVATE (self);
	self->priv->_fileSavingLock = FALSE;
	self->priv->_fileSaveRequested = FALSE;
}


static void journal_entry_finalize (GObject* obj) {
	JournalEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_JOURNAL_ENTRY, JournalEntry);
	_g_free0 (self->priv->yearDirPath);
	_g_free0 (self->priv->_archiveRelativeMonthPath);
	_g_free0 (self->priv->_monthDirPath);
	_g_free0 (self->priv->_filePath);
	_g_object_unref0 (self->priv->entryFile);
	_g_object_unref0 (self->priv->images);
	_g_date_time_unref0 (self->priv->_dateTime);
	G_OBJECT_CLASS (journal_entry_parent_class)->finalize (obj);
}


GType journal_entry_get_type (void) {
	static volatile gsize journal_entry_type_id__volatile = 0;
	if (g_once_init_enter (&journal_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (JournalEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) journal_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (JournalEntry), 0, (GInstanceInitFunc) journal_entry_instance_init, NULL };
		GType journal_entry_type_id;
		journal_entry_type_id = g_type_register_static (G_TYPE_OBJECT, "JournalEntry", &g_define_type_info, 0);
		g_once_init_leave (&journal_entry_type_id__volatile, journal_entry_type_id);
	}
	return journal_entry_type_id__volatile;
}


static void _vala_journal_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	JournalEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_JOURNAL_ENTRY, JournalEntry);
	switch (property_id) {
		case JOURNAL_ENTRY_ARCHIVE_RELATIVE_MONTH_PATH:
		g_value_set_string (value, journal_entry_get_archiveRelativeMonthPath (self));
		break;
		case JOURNAL_ENTRY_MONTH_DIR_PATH:
		g_value_set_string (value, journal_entry_get_monthDirPath (self));
		break;
		case JOURNAL_ENTRY_FILE_PATH:
		g_value_set_string (value, journal_entry_get_filePath (self));
		break;
		case JOURNAL_ENTRY_FILE_SAVING_LOCK:
		g_value_set_boolean (value, journal_entry_get_fileSavingLock (self));
		break;
		case JOURNAL_ENTRY_FILE_SAVE_REQUESTED:
		g_value_set_boolean (value, journal_entry_get_fileSaveRequested (self));
		break;
		case JOURNAL_ENTRY_DATE_TIME:
		g_value_set_boxed (value, journal_entry_get_dateTime (self));
		break;
		case JOURNAL_ENTRY_YEAR:
		g_value_set_int (value, journal_entry_get_year (self));
		break;
		case JOURNAL_ENTRY_MONTH:
		g_value_set_int (value, journal_entry_get_month (self));
		break;
		case JOURNAL_ENTRY_DAY:
		g_value_set_int (value, journal_entry_get_day (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_journal_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	JournalEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_JOURNAL_ENTRY, JournalEntry);
	switch (property_id) {
		case JOURNAL_ENTRY_ARCHIVE_RELATIVE_MONTH_PATH:
		journal_entry_set_archiveRelativeMonthPath (self, g_value_get_string (value));
		break;
		case JOURNAL_ENTRY_MONTH_DIR_PATH:
		journal_entry_set_monthDirPath (self, g_value_get_string (value));
		break;
		case JOURNAL_ENTRY_FILE_PATH:
		journal_entry_set_filePath (self, g_value_get_string (value));
		break;
		case JOURNAL_ENTRY_FILE_SAVING_LOCK:
		journal_entry_set_fileSavingLock (self, g_value_get_boolean (value));
		break;
		case JOURNAL_ENTRY_FILE_SAVE_REQUESTED:
		journal_entry_set_fileSaveRequested (self, g_value_get_boolean (value));
		break;
		case JOURNAL_ENTRY_DATE_TIME:
		journal_entry_set_dateTime (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



