/* UserSettingsManager.c generated by valac 0.30.0, the Vala compiler
 * generated from UserSettingsManager.vala, do not modify */

/*
 * DayJournal
 *
 * Copyright (C) 2013 Zach Burnham <thejambi@gmail.com>
 *
 * DayJournal is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * DayJournal is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <stdio.h>
#include <glib/gstdio.h>
#include <gee.h>


#define TYPE_USER_SETTINGS_MANAGER (user_settings_manager_get_type ())
#define USER_SETTINGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_SETTINGS_MANAGER, UserSettingsManager))
#define USER_SETTINGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_SETTINGS_MANAGER, UserSettingsManagerClass))
#define IS_USER_SETTINGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_SETTINGS_MANAGER))
#define IS_USER_SETTINGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_SETTINGS_MANAGER))
#define USER_SETTINGS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_SETTINGS_MANAGER, UserSettingsManagerClass))

typedef struct _UserSettingsManager UserSettingsManager;
typedef struct _UserSettingsManagerClass UserSettingsManagerClass;
typedef struct _UserSettingsManagerPrivate UserSettingsManagerPrivate;
#define _g_key_file_free0(var) ((var == NULL) ? NULL : (var = (g_key_file_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _UserSettingsManager {
	GObject parent_instance;
	UserSettingsManagerPrivate * priv;
};

struct _UserSettingsManagerClass {
	GObjectClass parent_class;
};

struct _UserSettingsManagerPrivate {
	GKeyFile* keyFile;
	gchar* djConfPath;
};


static gpointer user_settings_manager_parent_class = NULL;

GType user_settings_manager_get_type (void) G_GNUC_CONST;
#define USER_SETTINGS_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_USER_SETTINGS_MANAGER, UserSettingsManagerPrivate))
enum  {
	USER_SETTINGS_MANAGER_DUMMY_PROPERTY
};
#define USER_SETTINGS_MANAGER_djDirKey "djDirectory"
#define USER_SETTINGS_MANAGER_importJournalDirKey "importJournalDirectory"
#define USER_SETTINGS_MANAGER_blipDirKey "blipDirectory"
#define USER_SETTINGS_MANAGER_djGroup "DayJournal"
#define USER_SETTINGS_MANAGER_journalsGroup "Journals"
#define USER_SETTINGS_MANAGER_lockPastEntriesKey "lockPastEntries"
#define USER_SETTINGS_MANAGER_windowWidthKey "width"
#define USER_SETTINGS_MANAGER_windowHeightKey "height"
#define USER_SETTINGS_MANAGER_calendarFontSizeKey "calFontSize"
#define USER_SETTINGS_MANAGER_lastBlipLoadDateKey "lastBlipLoadDate"
#define USER_SETTINGS_MANAGER_NONE "NONE"
#define USER_SETTINGS_MANAGER_fontKey "font"
UserSettingsManager* user_settings_manager_new (void);
UserSettingsManager* user_settings_manager_construct (GType object_type);
const gchar* user_data_get_homeDirPath (void);
void file_utility_createFolder (const gchar* dirPath);
static gboolean user_settings_manager_processKeyFile (UserSettingsManager* self);
static void user_settings_manager_writeKeyFile (UserSettingsManager* self);
const gchar* user_data_get_djDirPath (void);
void user_data_set_djDirPath (const gchar* value);
gchar* user_data_getDefaultDjDir (void);
gboolean user_data_get_rememberCurrentJournalAfterInit (void);
void user_data_set_rememberCurrentJournalAfterInit (gboolean value);
const gchar* user_data_get_importJournalPath (void);
void user_data_set_importJournalPath (const gchar* value);
const gchar* user_data_get_blipDirPath (void);
void user_data_set_blipDirPath (const gchar* value);
gboolean user_data_get_lockPastEntries (void);
void user_data_set_lockPastEntries (gboolean value);
gint user_data_get_windowWidth (void);
void user_data_set_windowWidth (gint value);
gint user_data_get_windowHeight (void);
void user_data_set_windowHeight (gint value);
void zystem_debug (const gchar* s);
gint user_data_get_calendarFontSize (void);
void user_data_set_calendarFontSize (gint value);
const gchar* user_data_get_fontString (void);
void user_data_set_fontString (const gchar* value);
gint64 user_data_get_lastBlipLoadDate (void);
void user_data_set_lastBlipLoadDate (gint64 value);
void user_settings_manager_setDjDir (UserSettingsManager* self, const gchar* path);
void user_settings_manager_setLockPastEntries (UserSettingsManager* self, gboolean lockEm);
void user_settings_manager_setInt (UserSettingsManager* self, const gchar* key, gint val);
void user_settings_manager_setString (UserSettingsManager* self, const gchar* key, const gchar* val);
void user_settings_manager_deleteUISettings (UserSettingsManager* self);
void user_settings_manager_addJournal (UserSettingsManager* self, const gchar* name, const gchar* path);
void user_settings_manager_removeJournal (UserSettingsManager* self, const gchar* name);
GeeArrayList* user_settings_manager_getJournalList (UserSettingsManager* self);
static void user_settings_manager_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


/**
 * Constructor.
 */
UserSettingsManager* user_settings_manager_construct (GType object_type) {
	UserSettingsManager * self = NULL;
	gchar* settingsDirPath = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	GFile* settingsFile = NULL;
	const gchar* _tmp6_ = NULL;
	GFile* _tmp7_ = NULL;
	GFile* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	GKeyFile* _tmp16_ = NULL;
	gboolean _tmp22_ = FALSE;
	GError * _inner_error_ = NULL;
	self = (UserSettingsManager*) g_object_new (object_type, NULL);
	_tmp0_ = user_data_get_homeDirPath ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strconcat (_tmp1_, "/.config/dayjournal", NULL);
	settingsDirPath = _tmp2_;
	_tmp3_ = settingsDirPath;
	file_utility_createFolder (_tmp3_);
	_tmp4_ = settingsDirPath;
	_tmp5_ = g_strconcat (_tmp4_, "/dayjournal.conf", NULL);
	_g_free0 (self->priv->djConfPath);
	self->priv->djConfPath = _tmp5_;
	_tmp6_ = self->priv->djConfPath;
	_tmp7_ = g_file_new_for_path (_tmp6_);
	settingsFile = _tmp7_;
	_tmp8_ = settingsFile;
	_tmp9_ = g_file_query_exists (_tmp8_, NULL);
	if (!_tmp9_) {
		{
			GFile* _tmp10_ = NULL;
			GFileOutputStream* _tmp11_ = NULL;
			GFileOutputStream* _tmp12_ = NULL;
			_tmp10_ = settingsFile;
			_tmp11_ = g_file_create (_tmp10_, G_FILE_CREATE_NONE, NULL, &_inner_error_);
			_tmp12_ = _tmp11_;
			_g_object_unref0 (_tmp12_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch9_g_error;
			}
		}
		goto __finally9;
		__catch9_g_error:
		{
			GError* e = NULL;
			FILE* _tmp13_ = NULL;
			GError* _tmp14_ = NULL;
			const gchar* _tmp15_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp13_ = stderr;
			_tmp14_ = e;
			_tmp15_ = _tmp14_->message;
			fprintf (_tmp13_, "Error creating settings file: %s\n", _tmp15_);
			_g_error_free0 (e);
		}
		__finally9:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (settingsFile);
			_g_free0 (settingsDirPath);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp16_ = g_key_file_new ();
	_g_key_file_free0 (self->priv->keyFile);
	self->priv->keyFile = _tmp16_;
	{
		GKeyFile* _tmp17_ = NULL;
		const gchar* _tmp18_ = NULL;
		_tmp17_ = self->priv->keyFile;
		_tmp18_ = self->priv->djConfPath;
		g_key_file_load_from_file (_tmp17_, _tmp18_, 0, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch10_g_error;
		}
	}
	goto __finally10;
	__catch10_g_error:
	{
		GError* e = NULL;
		FILE* _tmp19_ = NULL;
		GError* _tmp20_ = NULL;
		const gchar* _tmp21_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp19_ = stderr;
		_tmp20_ = e;
		_tmp21_ = _tmp20_->message;
		fprintf (_tmp19_, "Error in UserSettingsManager(): %s\n", _tmp21_);
		_g_error_free0 (e);
	}
	__finally10:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (settingsFile);
		_g_free0 (settingsDirPath);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp22_ = user_settings_manager_processKeyFile (self);
	if (_tmp22_) {
		user_settings_manager_writeKeyFile (self);
	}
	_g_object_unref0 (settingsFile);
	_g_free0 (settingsDirPath);
	return self;
}


UserSettingsManager* user_settings_manager_new (void) {
	return user_settings_manager_construct (TYPE_USER_SETTINGS_MANAGER);
}


/**
 * Process the key file. Return true if keyFile needs to be written.
 */
static gint64 int64_parse (const gchar* str) {
	gint64 result = 0LL;
	const gchar* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
	g_return_val_if_fail (str != NULL, 0LL);
	_tmp0_ = str;
	_tmp1_ = g_ascii_strtoll (_tmp0_, NULL, (guint) 0);
	result = _tmp1_;
	return result;
}


static gboolean user_settings_manager_processKeyFile (UserSettingsManager* self) {
	gboolean result = FALSE;
	gchar* originalKeyFileData = NULL;
	GKeyFile* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp64_ = NULL;
	GKeyFile* _tmp65_ = NULL;
	gchar* _tmp66_ = NULL;
	gchar* _tmp67_ = NULL;
	gboolean _tmp68_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->keyFile;
	_tmp1_ = g_key_file_to_data (_tmp0_, NULL, NULL);
	originalKeyFileData = _tmp1_;
	{
		gchar* _tmp2_ = NULL;
		GKeyFile* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		_tmp3_ = self->priv->keyFile;
		_tmp4_ = g_key_file_get_string (_tmp3_, USER_SETTINGS_MANAGER_djGroup, USER_SETTINGS_MANAGER_djDirKey, &_inner_error_);
		_tmp2_ = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch11_g_key_file_error;
			}
			_g_free0 (originalKeyFileData);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		_tmp5_ = user_data_get_djDirPath ();
		_tmp6_ = _tmp5_;
		user_data_set_djDirPath (_tmp2_);
		_g_free0 (_tmp2_);
	}
	goto __finally11;
	__catch11_g_key_file_error:
	{
		GError* e = NULL;
		const gchar* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp7_ = user_data_get_djDirPath ();
		_tmp8_ = _tmp7_;
		_tmp9_ = user_data_getDefaultDjDir ();
		_tmp10_ = _tmp9_;
		user_data_set_djDirPath (_tmp10_);
		_g_free0 (_tmp10_);
		_tmp11_ = user_data_get_djDirPath ();
		_tmp12_ = _tmp11_;
		file_utility_createFolder (_tmp12_);
		_tmp13_ = user_data_get_rememberCurrentJournalAfterInit ();
		_tmp14_ = _tmp13_;
		user_data_set_rememberCurrentJournalAfterInit (TRUE);
		_g_error_free0 (e);
	}
	__finally11:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (originalKeyFileData);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	{
		gchar* _tmp15_ = NULL;
		GKeyFile* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
		const gchar* _tmp18_ = NULL;
		const gchar* _tmp19_ = NULL;
		_tmp16_ = self->priv->keyFile;
		_tmp17_ = g_key_file_get_string (_tmp16_, USER_SETTINGS_MANAGER_djGroup, USER_SETTINGS_MANAGER_importJournalDirKey, &_inner_error_);
		_tmp15_ = _tmp17_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch12_g_key_file_error;
			}
			_g_free0 (originalKeyFileData);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		_tmp18_ = user_data_get_importJournalPath ();
		_tmp19_ = _tmp18_;
		user_data_set_importJournalPath (_tmp15_);
		_g_free0 (_tmp15_);
	}
	goto __finally12;
	__catch12_g_key_file_error:
	{
		GError* e = NULL;
		const gchar* _tmp20_ = NULL;
		const gchar* _tmp21_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp20_ = user_data_get_importJournalPath ();
		_tmp21_ = _tmp20_;
		user_data_set_importJournalPath ("");
		_g_error_free0 (e);
	}
	__finally12:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (originalKeyFileData);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	{
		gchar* _tmp22_ = NULL;
		GKeyFile* _tmp23_ = NULL;
		gchar* _tmp24_ = NULL;
		const gchar* _tmp25_ = NULL;
		const gchar* _tmp26_ = NULL;
		_tmp23_ = self->priv->keyFile;
		_tmp24_ = g_key_file_get_string (_tmp23_, USER_SETTINGS_MANAGER_djGroup, USER_SETTINGS_MANAGER_blipDirKey, &_inner_error_);
		_tmp22_ = _tmp24_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch13_g_key_file_error;
			}
			_g_free0 (originalKeyFileData);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		_tmp25_ = user_data_get_blipDirPath ();
		_tmp26_ = _tmp25_;
		user_data_set_blipDirPath (_tmp22_);
		_g_free0 (_tmp22_);
	}
	goto __finally13;
	__catch13_g_key_file_error:
	{
		GError* e = NULL;
		const gchar* _tmp27_ = NULL;
		const gchar* _tmp28_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp27_ = user_data_get_blipDirPath ();
		_tmp28_ = _tmp27_;
		user_data_set_blipDirPath ("");
		_g_error_free0 (e);
	}
	__finally13:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (originalKeyFileData);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	{
		gboolean _tmp29_ = FALSE;
		GKeyFile* _tmp30_ = NULL;
		gboolean _tmp31_ = FALSE;
		gboolean _tmp32_ = FALSE;
		gboolean _tmp33_ = FALSE;
		_tmp30_ = self->priv->keyFile;
		_tmp31_ = g_key_file_get_boolean (_tmp30_, USER_SETTINGS_MANAGER_djGroup, USER_SETTINGS_MANAGER_lockPastEntriesKey, &_inner_error_);
		_tmp29_ = _tmp31_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch14_g_key_file_error;
			}
			_g_free0 (originalKeyFileData);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		_tmp32_ = user_data_get_lockPastEntries ();
		_tmp33_ = _tmp32_;
		user_data_set_lockPastEntries (_tmp29_);
	}
	goto __finally14;
	__catch14_g_key_file_error:
	{
		GError* e = NULL;
		gboolean _tmp34_ = FALSE;
		gboolean _tmp35_ = FALSE;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp34_ = user_data_get_lockPastEntries ();
		_tmp35_ = _tmp34_;
		user_data_set_lockPastEntries (TRUE);
		_g_error_free0 (e);
	}
	__finally14:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (originalKeyFileData);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	{
		gint _tmp36_ = 0;
		GKeyFile* _tmp37_ = NULL;
		gint _tmp38_ = 0;
		gint _tmp39_ = 0;
		gint _tmp40_ = 0;
		gint _tmp41_ = 0;
		GKeyFile* _tmp42_ = NULL;
		gint _tmp43_ = 0;
		gint _tmp44_ = 0;
		gint _tmp45_ = 0;
		_tmp37_ = self->priv->keyFile;
		_tmp38_ = g_key_file_get_integer (_tmp37_, USER_SETTINGS_MANAGER_djGroup, USER_SETTINGS_MANAGER_windowWidthKey, &_inner_error_);
		_tmp36_ = _tmp38_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch15_g_key_file_error;
			}
			_g_free0 (originalKeyFileData);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		_tmp39_ = user_data_get_windowWidth ();
		_tmp40_ = _tmp39_;
		user_data_set_windowWidth (_tmp36_);
		_tmp42_ = self->priv->keyFile;
		_tmp43_ = g_key_file_get_integer (_tmp42_, USER_SETTINGS_MANAGER_djGroup, USER_SETTINGS_MANAGER_windowHeightKey, &_inner_error_);
		_tmp41_ = _tmp43_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch15_g_key_file_error;
			}
			_g_free0 (originalKeyFileData);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		_tmp44_ = user_data_get_windowHeight ();
		_tmp45_ = _tmp44_;
		user_data_set_windowHeight (_tmp41_);
	}
	goto __finally15;
	__catch15_g_key_file_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		zystem_debug ("Error loading window size; using default.");
		_g_error_free0 (e);
	}
	__finally15:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (originalKeyFileData);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	{
		gint _tmp46_ = 0;
		GKeyFile* _tmp47_ = NULL;
		gint _tmp48_ = 0;
		gint _tmp49_ = 0;
		gint _tmp50_ = 0;
		_tmp47_ = self->priv->keyFile;
		_tmp48_ = g_key_file_get_integer (_tmp47_, USER_SETTINGS_MANAGER_djGroup, USER_SETTINGS_MANAGER_calendarFontSizeKey, &_inner_error_);
		_tmp46_ = _tmp48_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch16_g_key_file_error;
			}
			_g_free0 (originalKeyFileData);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		_tmp49_ = user_data_get_calendarFontSize ();
		_tmp50_ = _tmp49_;
		user_data_set_calendarFontSize (_tmp46_);
	}
	goto __finally16;
	__catch16_g_key_file_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		zystem_debug ("No saved calendar font size.");
		_g_error_free0 (e);
	}
	__finally16:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (originalKeyFileData);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	{
		gchar* _tmp51_ = NULL;
		GKeyFile* _tmp52_ = NULL;
		gchar* _tmp53_ = NULL;
		const gchar* _tmp54_ = NULL;
		const gchar* _tmp55_ = NULL;
		_tmp52_ = self->priv->keyFile;
		_tmp53_ = g_key_file_get_string (_tmp52_, USER_SETTINGS_MANAGER_djGroup, USER_SETTINGS_MANAGER_fontKey, &_inner_error_);
		_tmp51_ = _tmp53_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch17_g_key_file_error;
			}
			_g_free0 (originalKeyFileData);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		_tmp54_ = user_data_get_fontString ();
		_tmp55_ = _tmp54_;
		user_data_set_fontString (_tmp51_);
		_g_free0 (_tmp51_);
	}
	goto __finally17;
	__catch17_g_key_file_error:
	{
		GError* e = NULL;
		const gchar* _tmp56_ = NULL;
		const gchar* _tmp57_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp56_ = user_data_get_fontString ();
		_tmp57_ = _tmp56_;
		user_data_set_fontString ("");
		_g_error_free0 (e);
	}
	__finally17:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (originalKeyFileData);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	{
		gchar* _tmp58_ = NULL;
		GKeyFile* _tmp59_ = NULL;
		gchar* _tmp60_ = NULL;
		gint64 _tmp61_ = 0LL;
		gint64 _tmp62_ = 0LL;
		gint64 _tmp63_ = 0LL;
		_tmp59_ = self->priv->keyFile;
		_tmp60_ = g_key_file_get_string (_tmp59_, USER_SETTINGS_MANAGER_djGroup, USER_SETTINGS_MANAGER_lastBlipLoadDateKey, &_inner_error_);
		_tmp58_ = _tmp60_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch18_g_key_file_error;
			}
			_g_free0 (originalKeyFileData);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		_tmp61_ = user_data_get_lastBlipLoadDate ();
		_tmp62_ = _tmp61_;
		_tmp63_ = int64_parse (_tmp58_);
		user_data_set_lastBlipLoadDate (_tmp63_);
		_g_free0 (_tmp58_);
	}
	goto __finally18;
	__catch18_g_key_file_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		zystem_debug ("No saved last blip load date.");
		_g_error_free0 (e);
	}
	__finally18:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (originalKeyFileData);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	_tmp64_ = originalKeyFileData;
	_tmp65_ = self->priv->keyFile;
	_tmp66_ = g_key_file_to_data (_tmp65_, NULL, NULL);
	_tmp67_ = _tmp66_;
	_tmp68_ = g_strcmp0 (_tmp64_, _tmp67_) != 0;
	_g_free0 (_tmp67_);
	result = _tmp68_;
	_g_free0 (originalKeyFileData);
	return result;
}


void user_settings_manager_setDjDir (UserSettingsManager* self, const gchar* path) {
	GKeyFile* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = self->priv->keyFile;
	_tmp1_ = path;
	g_key_file_set_string (_tmp0_, USER_SETTINGS_MANAGER_djGroup, USER_SETTINGS_MANAGER_djDirKey, _tmp1_);
	user_settings_manager_writeKeyFile (self);
}


void user_settings_manager_setLockPastEntries (UserSettingsManager* self, gboolean lockEm) {
	GKeyFile* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->keyFile;
	_tmp1_ = lockEm;
	g_key_file_set_boolean (_tmp0_, USER_SETTINGS_MANAGER_djGroup, USER_SETTINGS_MANAGER_lockPastEntriesKey, _tmp1_);
	user_settings_manager_writeKeyFile (self);
}


/**
 * Write settings file.
 */
static void user_settings_manager_writeKeyFile (UserSettingsManager* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		const gchar* _tmp0_ = NULL;
		GKeyFile* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		_tmp0_ = self->priv->djConfPath;
		_tmp1_ = self->priv->keyFile;
		_tmp2_ = g_key_file_to_data (_tmp1_, NULL, NULL);
		_tmp3_ = _tmp2_;
		g_file_set_contents (_tmp0_, _tmp3_, (gssize) -1, &_inner_error_);
		_g_free0 (_tmp3_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch19_g_error;
		}
		zystem_debug ("Wrote KeyFile");
	}
	goto __finally19;
	__catch19_g_error:
	{
		GError* e = NULL;
		FILE* _tmp4_ = NULL;
		GError* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = stderr;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		fprintf (_tmp4_, "Error writing keyFile: %s\n", _tmp6_);
		_g_error_free0 (e);
	}
	__finally19:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


void user_settings_manager_setInt (UserSettingsManager* self, const gchar* key, gint val) {
	GKeyFile* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = self->priv->keyFile;
	_tmp1_ = key;
	_tmp2_ = val;
	g_key_file_set_integer (_tmp0_, USER_SETTINGS_MANAGER_djGroup, _tmp1_, _tmp2_);
	user_settings_manager_writeKeyFile (self);
}


void user_settings_manager_setString (UserSettingsManager* self, const gchar* key, const gchar* val) {
	GKeyFile* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	g_return_if_fail (val != NULL);
	_tmp0_ = self->priv->keyFile;
	_tmp1_ = key;
	_tmp2_ = val;
	g_key_file_set_string (_tmp0_, USER_SETTINGS_MANAGER_djGroup, _tmp1_, _tmp2_);
	user_settings_manager_writeKeyFile (self);
}


void user_settings_manager_deleteUISettings (UserSettingsManager* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GKeyFile* _tmp0_ = NULL;
		GKeyFile* _tmp1_ = NULL;
		GKeyFile* _tmp2_ = NULL;
		GKeyFile* _tmp3_ = NULL;
		_tmp0_ = self->priv->keyFile;
		g_key_file_remove_key (_tmp0_, USER_SETTINGS_MANAGER_djGroup, USER_SETTINGS_MANAGER_windowWidthKey, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch20_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp1_ = self->priv->keyFile;
		g_key_file_remove_key (_tmp1_, USER_SETTINGS_MANAGER_djGroup, USER_SETTINGS_MANAGER_windowHeightKey, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch20_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp2_ = self->priv->keyFile;
		g_key_file_remove_key (_tmp2_, USER_SETTINGS_MANAGER_djGroup, USER_SETTINGS_MANAGER_calendarFontSizeKey, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch20_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp3_ = self->priv->keyFile;
		g_key_file_remove_key (_tmp3_, USER_SETTINGS_MANAGER_djGroup, USER_SETTINGS_MANAGER_fontKey, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch20_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		user_settings_manager_writeKeyFile (self);
	}
	goto __finally20;
	__catch20_g_key_file_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		zystem_debug ("Failed to delete some settings.");
		_g_error_free0 (e);
	}
	__finally20:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


void user_settings_manager_addJournal (UserSettingsManager* self, const gchar* name, const gchar* path) {
	GKeyFile* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = self->priv->keyFile;
	_tmp1_ = name;
	_tmp2_ = path;
	g_key_file_set_string (_tmp0_, USER_SETTINGS_MANAGER_journalsGroup, _tmp1_, _tmp2_);
	user_settings_manager_writeKeyFile (self);
}


void user_settings_manager_removeJournal (UserSettingsManager* self, const gchar* name) {
	GKeyFile* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	_tmp0_ = self->priv->keyFile;
	_tmp1_ = name;
	g_key_file_remove_key (_tmp0_, USER_SETTINGS_MANAGER_journalsGroup, _tmp1_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	user_settings_manager_writeKeyFile (self);
}


GeeArrayList* user_settings_manager_getJournalList (UserSettingsManager* self) {
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	GKeyFile* _tmp2_ = NULL;
	gsize _tmp3_;
	gchar** _tmp4_ = NULL;
	gint _tmp1__length1 = 0;
	gint __tmp1__size_ = 0;
	gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
	list = _tmp0_;
	_tmp2_ = self->priv->keyFile;
	_tmp4_ = g_key_file_get_keys (_tmp2_, USER_SETTINGS_MANAGER_journalsGroup, &_tmp3_, &_inner_error_);
	_tmp1_ = _tmp4_;
	_tmp1__length1 = _tmp3_;
	__tmp1__size_ = _tmp1__length1;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (list);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp5_ = _tmp1_;
	_tmp5__length1 = _tmp1__length1;
	_tmp1_ = NULL;
	_tmp1__length1 = 0;
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
		s_collection = _tmp5_;
		s_collection_length1 = _tmp5__length1;
		for (s_it = 0; s_it < _tmp5__length1; s_it = s_it + 1) {
			gchar* _tmp6_ = NULL;
			gchar* s = NULL;
			_tmp6_ = g_strdup (s_collection[s_it]);
			s = _tmp6_;
			{
				const gchar* _tmp7_ = NULL;
				_tmp7_ = s;
				gee_abstract_collection_add ((GeeAbstractCollection*) list, _tmp7_);
				_g_free0 (s);
			}
		}
		s_collection = (_vala_array_free (s_collection, s_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	result = list;
	_tmp1_ = (_vala_array_free (_tmp1_, _tmp1__length1, (GDestroyNotify) g_free), NULL);
	return result;
}


static void user_settings_manager_class_init (UserSettingsManagerClass * klass) {
	user_settings_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (UserSettingsManagerPrivate));
	G_OBJECT_CLASS (klass)->finalize = user_settings_manager_finalize;
}


static void user_settings_manager_instance_init (UserSettingsManager * self) {
	self->priv = USER_SETTINGS_MANAGER_GET_PRIVATE (self);
}


static void user_settings_manager_finalize (GObject* obj) {
	UserSettingsManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_USER_SETTINGS_MANAGER, UserSettingsManager);
	_g_key_file_free0 (self->priv->keyFile);
	_g_free0 (self->priv->djConfPath);
	G_OBJECT_CLASS (user_settings_manager_parent_class)->finalize (obj);
}


/**
 * Manages User's Settings. This class deals with interactions with
 * data in the DayFolder settings file.
 */
GType user_settings_manager_get_type (void) {
	static volatile gsize user_settings_manager_type_id__volatile = 0;
	if (g_once_init_enter (&user_settings_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UserSettingsManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) user_settings_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UserSettingsManager), 0, (GInstanceInitFunc) user_settings_manager_instance_init, NULL };
		GType user_settings_manager_type_id;
		user_settings_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "UserSettingsManager", &g_define_type_info, 0);
		g_once_init_leave (&user_settings_manager_type_id__volatile, user_settings_manager_type_id);
	}
	return user_settings_manager_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



